
{TurboPascal 7.0 Programm zur Demonstration des Equipment-Auswerten}
{(c) alle Rechte bei Manfred Fischer, Heroldstr. 44, D-48163 Mnster}
{18.Mrz 1995}

Program Check;

{$IFNDEF VER30 }
Uses Dos, RS232;
{$ENDIF}

(* 12.07.1986 === Checking the Equipment of a Standard-PC *)
(* Literatur: MC 6/1986, Seite 41 *)

(*' TYPE                                           '*)
(*' Registers =                                    '*)
(*' record                                         '*)
(*'     ax,bx,cx,dx,bp,si,di,ds,es,flags: Word;    '*)
(*' end;                                           '*)

Function Equipment : Word;
VAR recpack     :   Registers;
begin
  Intr($11,recpack);       (* equipment check *)
  Equipment:=recpack.ax;
end;

Function RAMSize : Word;
VAR recpack :   Registers;
begin
  intr($12,recpack);         (* memory size detect *)
  RAMSize:=recpack.ax
end;


Procedure InterpretEquipment;
VAR Equip : integer;
begin
    Equip := Equipment;
    if not Odd(Equip) then write('no ');
    writeln('Diskette Drive(s) installed');
    writeln(Succ((Equip shr 2) AND 3),' Memory Banks');
    case (Equip shr 4) AND 3 of
     0 : writeln('reserved Displaytype');
     1 : writeln('40x25 Line, B/W and Colour');
     2 : writeln('80x25 Line, B/W and Colour');
     3 : writeln('IBM Monochrome Display');
    end;
    writeln(Succ((Equip shr 6) AND 3),' Diskette Drives');
    writeln(((Equip shr 9) AND 7),' COM-Ports');
    writeln(((Equip shr 14) AND 3),' LPT-Ports');
    if (((Equip shr 12) AND 1) = 0) then write('no ');
    writeln('Game-Card');
    write(RAMSize,' kB RAM');
end;


Procedure InterpretMsDos;
Const MsDosIntr      = $21;  {Betriebssystem Funktionen}
Var Regs : Dos.Registers;
    Zwisch : array[0..255] of Byte;
    Loop : Byte;
begin
  with Regs do
  begin
    ah := $30; {Version Nr}
    Intr(MsDosIntr, Regs);
    writeln('MsDos Version  ',al,'.',ah);

    ax := $3800; {Country}
    ds := Seg(Zwisch);
    dx := Ofs(Zwisch);
    Intr(MsDosIntr,Regs);
    writeln('aktuelles Land 0',al);

    ax := $3300; {Ctrl-C Check}
    (* al := $00; *) {request}
    Intr(MsDosIntr,Regs);
    write('BREAK          ');
    if (dl = 0) then writeln('OFF') else writeln('ON');

    ah := $54; {Verify}
    Intr(MsDosIntr,Regs);
    write('VERIFY         ');
    if (al = 0) then writeln('OFF') else writeln('ON');

    ah := $19; {CurrentDisk}
    Intr(MsDosIntr,Regs);
    writeln('aktuelles Lw.  ',chr(65 + al),':');

    ah := $0E; {SelectDisk}
    dl := al;
    Intr(MsDosIntr,Regs);
    write('Laufwerke ');
    for Loop := 1 to al do write(' ',Chr(64 + Loop),':');
  end;
  writeln;
end;

Procedure InterpretPorts;
Const PrtIntr        = $17;  {BIOS Printer Interrupt}
Var Regs : Dos.Registers;
    Loop : Byte;
begin
  {parallele Schnittstellen}
  with Regs do
  begin
    for Loop := 1 to ((Equipment shr 14) AND 3) do
    begin
      ah := 2; {read printer status}
      dx := Pred(Loop);
      Intr(PrtIntr,Regs);
      writeln;
      write('LPT',Loop,':          ');
      case ah of
        $90,$10 : write('Online');
        $30     : write('Offline');
        else      write('Fehler');
      end;
    end;
  end;
  {serielle Schnittstellen}
  for Loop := 1 to ((Equipment shr 9) AND 3) do
  begin
    writeln;
    write('COM',Loop,':          ',RS232.IdentifyComStatus(Loop));
  end;
  writeln;
end;

Procedure InterpretEnvironment;
TYPE
  Umgebung = array[1..MaxInt] of Char;
VAR
  UmgebungPtr : ^Umgebung;
  Loop : Word;

begin
  {$IFNDEF VER30}
  UmgebungPtr := Ptr(MemW[PrefixSeg : $2C],0);
  {$ELSE}
  UmgebungPtr := Ptr(MemW[CSeg : $2C],0);
  {$ENDIF}
  Loop := 1;
  while not((UmgebungPtr^[Loop] = #0)and(UmgebungPtr^[Succ(Loop)] = #0)) do
  begin
    if (UmgebungPtr^[Loop] = #0)
    and(UmgebungPtr^[Succ(Loop)] <> #0) then writeln
    else write(UmgebungPtr^[Loop]);
    Inc(Loop);
  end;
end;


begin
  InterpretEquipment;
  InterpretPorts;
  InterpretMsDos;
  InterpretEnvironment;
end.
