
{Datei: C:\Pascal\Progs6\Uhlenbro.Pas }
{TurboPascal 7.0 Programm zum Programmieren des Uhlenbrock-Digital-}
{decoders DAL 770; (c) Manfred G. Fischer, D-48163 Mnster, 12.Juli 1995}
{alle Rechte vorbehalten}

Program UhlenbrockDecoderProgrammierung;

Uses Crt, RS232, RollMenu, ScreenIO, BigText1, Digital;

Const Titel : String[35] = 'Decoder DAL 770-Programmierung';
      Version : String[4] = '1.00';
      UhlenbrockAdresseMin = 1;  {der DAL 770 akzeptiert den Adressenbereich}
      UhlenbrockAdresseMax = 79; {von 1 bis 79}
      UhlenbrockVerzoegerMin = 1;  {der DAL 770 ist bei Beschleunigungs- und}
      UhlenbrockVerzoegerMax = 79; {Bremsverzgerung einstellbar zwischen 1 u. 79}
      UhlenbrockProgrammingEndAdresse = 80;
      UhlenbrockDefaultAdresse = 1; {so wird er vom Werk ausgeliefert}
      HeadingLine = 3;
      MenuTopLine = 5;
      MenuSchnittstelle = 0;
      MenuAlteAdresse   = 1;
      MenuNeueAdresse   = 2;
      MenuVmin          = 3;
      MenuVmax          = 4;
      MenuBeschleunigung= 5;
      MenuVerzoegerung  = 6;
      MenuBefehle       = 7;

      MenuInaktivFarbe = LightGray;
      MenuAktivFarbe   = White;
      MenuInaktivPapier= Green;
      MenuAktivPapier  = LightGreen;

      DesktopFarbe     = Black;
      DesktopPapier    = MenuInaktivPapier;

      BefehlNull         = 0;
      BefehlEnde         = 1;
      BefehlProgrammiere = 2;
      BefehlDefault      = 3;
      BefehlDigital      = 4;
      BefehlAnalog       = 5;
      BefehlControl80    = 6;

Type String5 = String[5];

     DAL770 = Record
       DigitalAdresse : UhlenbrockAdresseMin..UhlenbrockAdresseMax; {von 1 bis 79}
       DigitalVmin    : Vmin..Vmax; {Mrklin-Bereich 1..14}
       DigitalVmax    : Vmin..Vmax; {Mrklin-Bereich 1..14}
       DigitalStart   : UhlenbrockVerzoegerMin..UhlenbrockVerzoegerMax;
       DigitalBrems   : UhlenbrockVerzoegerMin..UhlenbrockVerzoegerMax;
     end;

Const DefaultDAL770 : DAL770 =
      (DigitalAdresse : 01; DigitalVmin : 01; DigitalVmax : 14;
       DigitalStart : 01; DigitalBrems : 01);

Var M : array[MenuSchnittstelle..MenuBefehle] of RollMenuType;
    AktivesMenu : MenuSchnittstelle..MenuBefehle;
    Aufgabe : BefehlNull..BefehlDefault;
    AktuelleAlteAdresse : UhlenbrockAdresseMin..UhlenbrockAdresseMax; {von 1 bis 79}
    AktuellerDAL770 : DAL770;


Function CToB(Ch : Char) : Byte; {Char To Byte}
begin
  CToB := Ord(Ch) - Ord('0');
end;

Function BToC(B : Word) : Char; {Byte To Char}
begin
  BToC := Chr((B MOD 10) + Ord('0'));
end;

Function WToS(W : Word; Laenge : Byte) : String5; {Word To String}
begin
  WToS := Copy(BToC(W DIV 10000) + BToC(W DIV 1000) + BToC(W DIV 100)
               + BToC(W DIV 10) + BToC(W MOD 10), 6 - Laenge, Laenge);
end;


Procedure Control80(ComPortNo : Byte); {simuliert Control 80, siehe CONTROL8.EXE}

Const x1 = 10; {Fenstergrenzen}
      x2 = x1 + 34;
      y1 = 3;
      y2 = y1 + 7;
      StopChar = EscapeKey; {Taste fr Programmstop}

Var DigitalAdresse : array[0..LokAdresseMax] of record {1. Feld[0] dient als Dummy}
      Geschwindigkeit : Vstop..Vmax; {0..14}
      Umschalten : Boolean;
      FunktionAn : Boolean;
    end;
    AktuelleAdresse : Word;
    FreigabeTaste, NotHaltTaste, NotHaltGesendet : Boolean;
    Loop : Byte; {Laufvariable}
    Ch : Char; {fr Tastaturabfrage}
    Sekunde : Word; {Zeitnahme}

begin
  {Initialisierung}
  for AktuelleAdresse := 0 to LokAdresseMax do
  with DigitalAdresse[AktuelleAdresse] do
  begin
    Geschwindigkeit := Vstop;
    Umschalten := FALSE;
    FunktionAn := FALSE;
  end;
  AktuelleAdresse := 0;
  FreigabeTaste := FALSE;
  NotHaltTaste := FALSE;
  NotHaltGesendet := FALSE;
  Ch := 'A';

  SetComPort(ComPortNo);
  DigitalInterfaceInit;
  Sekunde := Sekundenzeiger;

  {Fuzeile anzeigen}
  Farben(15,3);
  LoescheZeile(25);
  write(' <0..9> Digital-Adr. <+>/<-> Geschw. <F>unktion an/aus <U>mschalten <S>top <G>o');

  {Fenster initialisieren}
  Farben(0,3);
  MakeFenster(x1,y1,x2,y2,1);
  GotoXY(x1+2,y1);
  write('Control fr ',LokAdresseMax,' Lok-Adressen');
  GotoXY(x1+2,y2);
  write('Ende mit <ESC>');
  GotoXY(x1+1,y1+5);
  write('<+><-> ');
  {Adresse anzeigen}
  Farben(15,3);
  GotoXY(x1+2,y1+2);
  WriteBiLine2x3(BToC(AktuelleAdresse DIV 10));
  WriteBiLine2x3(BToC(AktuelleAdresse MOD 10));

  repeat
    {Tastatur auswerten}
    if TastaturAktiviert then
    begin
      if ReadUpCaseKey(Ch) then {Funktionstate gedrckt};
      case Ch of
        'G' : FreigabeTaste := TRUE;
        'S' : if not NotHaltGesendet then NotHaltTaste := TRUE;
        '0'..'9' : begin
           AktuelleAdresse := (AktuelleAdresse * 10) + CToB(Ch);
           if (AktuelleAdresse > LokAdresseMax) then AktuelleAdresse := CToB(Ch);
        end;
        else if (AktuelleAdresse in [LokAdresseMin..LokAdresseMax]) then
        with DigitalAdresse[AktuelleAdresse] do
        begin
          case Ch of
            '+' : if (Geschwindigkeit < Vmax) then Inc(Geschwindigkeit);
            '-' : if (Geschwindigkeit > Vstop) then Dec(Geschwindigkeit);
            'U' : begin
                    Umschalten := TRUE;
                    Geschwindigkeit := 0;
                  end;
            'F' : FunktionAn := not FunktionAn;
          end;
        end;
      end;

      {Adresse anzeigen}
      GotoXY(x1+2,y1+2);
      WriteBiLine2x3(BToC(AktuelleAdresse DIV 10));
      WriteBiLine2x3(BToC(AktuelleAdresse MOD 10));

      {Geschwindigkeit anzeigen}
      GotoXY(x1+8,y1+5);
      write(Vstop);
      with DigitalAdresse[AktuelleAdresse] do
      begin
        for Loop := Succ(Vstop) to Geschwindigkeit do write('-');
        write(SEC2);
        for Loop := Succ(Geschwindigkeit) to Vmax do write('-');
        write(Vmax);

        {Umschaltbefehl ?}
        if Umschalten then write('<U>') else write('   ');
        if FunktionAn then write('<F>') else write('   ');
      end;

      {Nothalt und Freigabe anzeigen}
      GotoXY(x1+26,y1+3);
      if NotHaltTaste then write('<S>   ')
      else if FreigabeTaste then write('   <G>');
    end; {TastaturAktiviert}


    {Senden}
    if NotHaltTaste then
    begin
      NotHalt;
      NotHaltGesendet := TRUE;
      NotHaltTaste := FALSE;
    end
    else if FreigabeTaste then
    begin
      Freigabe;
      NotHaltGesendet := FALSE;
      FreigabeTaste := FALSE;
    end
    else if (AktuelleAdresse in [LokAdresseMin..LokAdresseMax])
    and not NotHaltGesendet then
    begin
      with DigitalAdresse[AktuelleAdresse] do
      begin
        if Umschalten then
        begin
          LokUmschalten(AktuelleAdresse,FunktionAn);
          Umschalten := FALSE;
        end
        else {regelmig Befehl wiederholen, einmal pro Sekunde}
        begin
          if (Sekunde <> Sekundenzeiger) then
          begin
            LokBefehl(AktuelleAdresse,Geschwindigkeit,FunktionAn);
            Sekunde := Sekundenzeiger;
          end;
        end;
      end;
    end;
  until (Ch = StopChar);
end;


Procedure MenuWechseln(Von, Nach : Byte);
begin
  Farben(MenuInaktivFarbe,MenuInaktivPapier);
  with M[Von] do MakeFenster(x0,y0,x0+Breite-1,y0+DownIndex-TopIndex+2,0);
  RollMenuShow(M[Von]);
  Farben(MenuAktivFarbe,MenuAktivPapier);
  with M[Nach] do
  begin
    MakeFenster(x0,y0,x0+Breite-1,y0+DownIndex-TopIndex+2,1);
    if (Nach in [MenuAlteAdresse..MenuVerzoegerung]) then
    begin
      GotoXY(x0+Breite-1,y0+1); write(PfeilNachOben);
      GotoXY(x0+Breite-1,y0+DownIndex-TopIndex+1); write(PfeilNachUnten);
    end;
  end;
  RollMenuShow(M[Nach]);
end;

Procedure WerteInMenusUebertragen;

  Procedure MenuPositionieren(MenuNr : Byte; NeuePosition : Byte);
  Var Loop : Byte;
      RC : Integer;
  begin
    with M[MenuNr] do
    begin
      if (AktuIndex <= NeuePosition) then
        for Loop := Succ(AktuIndex) to NeuePosition do
          RC := RollMenuAktion(M[MenuNr],Ord(DownKey))
      else
        for Loop := Pred(AktuIndex) downto NeuePosition do
          RC := RollMenuAktion(M[MenuNr],Ord(UpKey));
    end;
  end;

begin
  MenuPositionieren(MenuAlteAdresse, AktuelleAlteAdresse);
  with AktuellerDAL770 do
  begin
    MenuPositionieren(MenuNeueAdresse, DigitalAdresse);
    MenuPositionieren(MenuVmin, DigitalVmin);
    MenuPositionieren(MenuVmax, DigitalVmax);
    MenuPositionieren(MenuBeschleunigung, DigitalStart);
    MenuPositionieren(MenuVerzoegerung, DigitalBrems);
  end;
end;

Procedure WerteAusMenusUebernehmen;
begin
  AktuelleAlteAdresse := M[MenuAlteAdresse].AktuIndex;
  with AktuellerDAL770 do
  begin
    DigitalAdresse := M[MenuNeueAdresse].AktuIndex;
    DigitalVmin := M[MenuVmin].AktuIndex;
    DigitalVmax := M[MenuVmax].AktuIndex;
    DigitalStart := M[MenuBeschleunigung].AktuIndex;
    DigitalBrems := M[MenuVerzoegerung].AktuIndex;
  end;
end;


Procedure MenuInit;
Var Loop : Integer;
begin
  RollMenuInit(M[MenuSchnittstelle],3,MenuTopLine,6,11);
  RollMenuAppend(M[MenuSchnittstelle],'COM1:');
  RollMenuAppend(M[MenuSchnittstelle],'COM2:');
  RollMenuAppend(M[MenuSchnittstelle],'COM3:');
  RollMenuAppend(M[MenuSchnittstelle],'COM4:');

  RollMenuInit(M[MenuAlteAdresse],
               M[MenuSchnittstelle].x0 + M[MenuSchnittstelle].Breite + 1,
               MenuTopLine,6,8);

  RollMenuInit(M[MenuNeueAdresse],
               M[MenuAlteAdresse].x0 + M[MenuAlteAdresse].Breite + 1,
               MenuTopLine,6,8);

  for Loop := UhlenbrockAdresseMin to UhlenbrockAdresseMax do
  begin
    RollMenuAppend(M[MenuAlteAdresse],WToS(Loop,2));
    RollMenuAppend(M[MenuNeueAdresse],WToS(Loop,2));
  end;

  RollMenuInit(M[MenuVmin],
               M[MenuNeueAdresse].x0 + M[MenuNeueAdresse].Breite + 1,
               MenuTopLine,6,8);

  RollMenuInit(M[MenuVmax],
               M[MenuVmin].x0 + M[MenuVmin].Breite + 1,
               MenuTopLine,6,8);

  for Loop := Vmin to Vmax do
  begin
    RollMenuAppend(M[MenuVmin],WToS(Loop,2));
    RollMenuAppend(M[MenuVmax],WToS(Loop,2));
  end;

  RollMenuInit(M[MenuBeschleunigung],
               M[MenuVmax].x0 + M[MenuVmax].Breite + 1,
               MenuTopLine,6,8);

  RollMenuInit(M[MenuVerzoegerung],
               M[MenuBeschleunigung].x0 + M[MenuBeschleunigung].Breite + 1,
               MenuTopLine,6,8);

  for Loop := UhlenbrockVerzoegerMin to UhlenbrockVerzoegerMax do
  begin
    RollMenuAppend(M[MenuBeschleunigung],WToS(Loop,2));
    RollMenuAppend(M[MenuVerzoegerung],WToS(Loop,2));
  end;

  RollMenuInit(M[MenuBefehle],
               M[MenuVerzoegerung].x0 + M[MenuVerzoegerung].Breite + 1,
               MenuTopLine,8,26);
  RollMenuAppend(M[MenuBefehle],'Ende');
  RollMenuAppend(M[MenuBefehle],'Lok-Programmieren...');
  RollMenuAppend(M[MenuBefehle],'Default-Werte nehmen');
  RollMenuAppend(M[MenuBefehle],'Digital einstellen');
  RollMenuAppend(M[MenuBefehle],'Analogbetrieb einst.');
  RollMenuAppend(M[MenuBefehle],'Control 80-Simulator');
  WerteInMenusUebertragen;
end;

Procedure MenuShow;
Var Loop : Integer;
begin
  Farben(DesktopFarbe,DesktopPapier);
  MakeFenster(1,2,80,13,2);
  GotoXY(2,2);
  write(Titel,' ',Version);
  Farben(MenuAktivFarbe,DesktopPapier);
  GotoXY(4,HeadingLine);
  write('            Adresse      Geschwin.    Verzgerung               ');
  GotoXY(4,HeadingLine+1);
  write('PC-Port   alte   neue   Vmin   Vmax   Start  Brems   ...ausfhren mit <CR>');
  Farben(MenuInaktivFarbe,MenuInaktivPapier);
  RollMenuShow(M[MenuBefehle]);
  for Loop := MenuSchnittstelle to MenuVerzoegerung do RollMenuShow(M[Loop]);

  Farben(15,3);
  LoescheZeile(25);
  write(' <ESC> Ende;  ',
        PfeilNachOben,PfeilNachLinks,PfeilNachUnten,PfeilNachRechts,
        ' Werte einstellen bzw. Menpunkt auswhlen');

  AktivesMenu := MenuBefehle;
  MenuWechseln(AktivesMenu,AktivesMenu);
end;


Procedure TastaturAuswertung;
Var Ch : Char;
    Old : MenuSchnittstelle..MenuBefehle;
    ReturnCode : Integer; {was RollMenuAktion liefert}
begin
  if TastaturAktiviert then
  begin
    if ReadUpCaseKey(Ch) then {FunktionsTaste}
    case Ch of
      ShiftTabKey, LeftKey : begin {ein Menu weiter nach links}
        Old := AktivesMenu;
        if (AktivesMenu = MenuSchnittstelle) then AktivesMenu := MenuBefehle
        else Dec(AktivesMenu);
        MenuWechseln(Old,AktivesMenu);
      end;
      RightKey : begin {ein Menu weiter nach rechts}
        Old := AktivesMenu;
        if (AktivesMenu = MenuBefehle) then AktivesMenu := MenuSchnittstelle
        else Inc(AktivesMenu);
        MenuWechseln(Old,AktivesMenu);
      end;
      DownKey, UpKey : begin
        ReturnCode := RollMenuAktion(M[AktivesMenu],Ord(Ch));
      end;
    end
    else
    begin
      case Ch of
        TabKey : begin {ein Menu weiter nach rechts}
          Old := AktivesMenu;
          if (AktivesMenu = MenuBefehle) then AktivesMenu := MenuSchnittstelle
          else Inc(AktivesMenu);
          MenuWechseln(Old,AktivesMenu);
        end;
        EscapeKey : begin
          Aufgabe := BefehlEnde;
        end;
        else
        begin
          ReturnCode := RollMenuAktion(M[AktivesMenu],Ord(Ch));
          if (ReturnCode in [BefehlNull..BefehlControl80]) then
            Aufgabe := ReturnCode
          else Aufgabe := BefehlNull;
        end;
      end;
    end;
  end;
end;


Procedure ProtokollEbeneEinrichten;
Var Loop : Byte;
begin
  Farben(15,0);
  for Loop := 14 to 24 do LoescheZeile(Loop);
  GotoXY(1,14);
end;


{--------------------------------------------------------------}
{ Uhlenbrock DAL 770 spezifische Unterprogramme
    a) Einschalten des Programmiermodus
    b) Auswahl eines bestimmten Unterprogramms
         01: Lokadresse ndern,
         02: Vmin einstellen,
         03: Vmax einstellen,
         06: Beschleunigungsverzgerung einstellen,
         07: Bremsverzgerung einstellen,
         08: Betriebsart einstellen:  01: Analog, 02: Digital,
         10: alle Werte rcksetzen auf Default.
    c) Programmiermodus beenden }
{--------------------------------------------------------------}

Const
  Wartezeit = 5000; {5 sec}

Procedure DAL770ProgrammiermodusInit(AlteAdresse : Byte);
Var Loop : Integer;
begin
  ProtokollEbeneEinrichten;
  SetComPort(M[MenuSchnittstelle].AktuIndex);
  DigitalInterfaceInit;
  write('Init COM',BToC(M[MenuSchnittstelle].AktuIndex),
        ':  ',RS232.IdentifyComStatus(Digital.ComPort));

  Delay(300); {Millisekunden}
  Freigabe; Freigabe;
  Delay(300);
  LokHalt(AlteAdresse,TRUE); {Stop und Licht an}
  Delay(2500);
  writeln(' ...freigegeben');
  write('Umschalten: ');

  for Loop := 1 to 12 do
  begin
    LokBefehl(AlteAdresse,Vturn,TRUE);
    Delay(800);
    write('*');
  end;
  writeln(' ...im Programmiermodus Adr. ',AlteAdresse,'  4x lang blinken');
  LokHalt(AlteAdresse,FALSE);
  Delay(5000);
end;

Procedure DAL770UnterprogrammWahl(Upro : Byte);
begin
  if Upro in [01,02,03,06,07,08,10] then
  begin
    LokHalt(Upro,FALSE);
    Delay(150);
    LokBefehl(Upro,Vturn,FALSE);
    Delay(150);
    write('4 mal ');
    if (Upro = 10) then write('langes')
    else write('kurzes');
    write(' Aufblinken ? (Upro ',Upro,')  ');
    LokHalt(Upro,FALSE);
    Delay(Wartezeit); {5sec warten}
  end;
end;

Procedure DAL770ProgrammierEnde(AlteAdresse, Upro : Byte);
begin
  LokBefehl(80,Vturn,FALSE);
  Delay(150);
  writeln('Programmierung beendet.');
  LokHalt(80,FALSE);
  LokHalt(AlteAdresse,FALSE);
  LokHalt(Upro,FALSE);
end;


Procedure DAL770Ruecksetzen(AlteAdresse : Byte);
begin
  DAL770ProgrammiermodusInit(AlteAdresse);
  DAL770UnterprogrammWahl(10);
  writeln('  zurckgesetzt. Neue Adresse = 01');
  DAL770ProgrammierEnde(AlteAdresse, 10);
end;


Procedure DAL770Programmieren(AlteAdresse : Byte;
                              NeueWerte : DAL770);
begin
  DAL770ProgrammiermodusInit(AlteAdresse);

  with NeueWerte do
  begin
    if (AlteAdresse <> DigitalAdresse) then
    begin {neue Adresse einstellen}
      DAL770UnterprogrammWahl(01);
      LokHalt(DigitalAdresse,FALSE);
      Delay(300);
      LokBefehl(DigitalAdresse,Vturn,FALSE);
      Delay(300);
      LokHalt(DigitalAdresse,FALSE);
      write('Adr. ',DigitalAdresse,'  ');
      DAL770ProgrammierEnde(AlteAdresse, 01);
      Delay(Wartezeit);
      DAL770ProgrammiermodusInit(DigitalAdresse);
    end;

    {Vmin einstellen}
    DAL770UnterprogrammWahl(02);
    LokBefehl(02, DigitalVmin, FALSE);
    Delay(3000); {Lok 3sec fahren lassen}
    LokBefehl(02, DigitalVmin, TRUE);
    Delay(500);
    LokBefehl(02, DigitalVmin, FALSE);
    writeln('   Vmin: ',DigitalVmin,'   4x lang blinken');
    Delay(500);
    LokHalt(02,FALSE);
    Delay(Wartezeit);

    {Vmax einstellen}
    DAL770UnterprogrammWahl(03);
    LokBefehl(03, DigitalVmax, FALSE);
    Delay(1500); {Lok 1,5sec fahren lassen}
    LokBefehl(03, DigitalVmax, TRUE);
    Delay(500);
    LokBefehl(03, DigitalVmax, FALSE);
    writeln('   Vmax: ',DigitalVmax,'   4x lang blinken');
    Delay(500);
    LokHalt(03,FALSE);
    Delay(Wartezeit);

    {Beschleunigung einstellen}
    DAL770UnterprogrammWahl(06);
    LokHalt(DigitalStart,FALSE);
    Delay(300);
    LokBefehl(DigitalStart, Vturn, FALSE);
    Delay(300);
    writeln('   Beschleun.: ',DigitalStart,'   4x lang blinken');
    LokHalt(DigitalStart,FALSE);
    Delay(Wartezeit);

    {Bremsverzgerung einstellen}
    DAL770UnterprogrammWahl(07);
    LokHalt(DigitalBrems,FALSE);
    Delay(300);
    LokBefehl(DigitalBrems, Vturn, FALSE);
    Delay(300);
    LokHalt(DigitalBrems,FALSE);
    writeln('   Bremsverz.: ',DigitalBrems,'   4x lang blinken');
    Delay(Wartezeit);
  end;

  DAL770ProgrammierEnde(AlteAdresse, 07);
end;


Procedure DAL770BetriebsartWahl(AlteAdresse : Byte; Analog : Boolean);
begin
  DAL770ProgrammiermodusInit(AlteAdresse);

  DAL770UnterprogrammWahl(08);
  if Analog then
  begin
    LokHalt(01, FALSE);
    Delay(300);
    LokBefehl(01, Vturn, FALSE);
    writeln('  ANALOG-Betrieb eingestellt.');
    Delay(300);
    LokHalt(01, FALSE);
  end
  else {Digitalbetrieb}
  begin
    LokHalt(02, FALSE);
    Delay(300);
    LokBefehl(02, Vturn, FALSE);
    writeln('  DIGITAL-Betrieb eingestellt.');
    Delay(300);
    LokHalt(02, FALSE);
  end;
  Delay(300);

  DAL770ProgrammierEnde(AlteAdresse, 08);
end;


Procedure BefehleAusfuehren;
begin
  case Aufgabe of
    BefehlEnde : begin
      Aufgabe := BefehlEnde;
    end;
    BefehlProgrammiere : begin
      WerteAusMenusUebernehmen;
      DAL770Programmieren(AktuelleAlteAdresse,AktuellerDAL770);
      AktuelleAlteAdresse := AktuellerDAL770.DigitalAdresse;
      WerteInMenusUebertragen;
      Aufgabe := BefehlNull; {weiter die Schleife fortsetzen}
    end;
    BefehlDefault : begin
      DAL770Ruecksetzen(AktuellerDAL770.DigitalAdresse);
      AktuellerDAL770 := DefaultDAL770;
      AktuelleAlteAdresse := DefaultDAL770.DigitalAdresse;
      WerteInMenusUebertragen;
      Aufgabe := BefehlNull; {weiter die Schleife fortsetzen}
    end;
    BefehlDigital : begin
      DAL770BetriebsartWahl(AktuelleAlteAdresse, FALSE);
      Aufgabe := BefehlNull;
    end;
    BefehlAnalog : begin
      DAL770BetriebsartWahl(AktuelleAlteAdresse, TRUE);
      Aufgabe := BefehlNull;
    end;
    BefehlControl80 : begin
      ProtokollEbeneEinrichten;
      write('Init COM',BToC(M[MenuSchnittstelle].AktuIndex),
            ':  ',RS232.IdentifyComStatus(M[MenuSchnittstelle].AktuIndex));
      Control80(M[MenuSchnittstelle].AktuIndex);
      MenuShow;
      Aufgabe := BefehlNull;
    end;
  end;
end;


begin {Hauptprogramm}
  if (ParamCount <> 0) or (Length(Version) = 0) then
  begin       {Kommandozeilenparameter-Auswertung}
    writeln('UHLENBROCK-',Titel,' ******* 1995',
      #13#10' (c) alle Rechte bei Manfred Fischer, D-48163 Mnster ',
      #13#10,
      #13#10'Mengesteuerte Programmierung des Wechselstrom-Modell-',
      #13#10'eisenbahn-Decoders DAL 770. Eingestellt werden knnen',
      #13#10'Lokadresse, maximale u. minimale Geschwindigkeit, Start-',
      #13#10'u. Bremsverzgerung, Betriebsart (analog oder digital)',
      #13#10'sowie die Einstellung der werksseitigen Default-Werte.',
      #13#10,
      #13#10'Arbeitet mit den Schnittstellen COM1: bis COM4:.',
      #13#10'Aufruf des Programms ohne Parameter, sonst wird dieser',
      #13#10'Hilfstext angezeigt.');
    Halt(1);
  end;

  Aufgabe := BefehlNull;
  AktuelleAlteAdresse := DefaultDAL770.DigitalAdresse;
  AktuellerDAL770 := DefaultDAL770;
  MenuInit;
  MenuShow;
  repeat
    TastaturAuswertung;
    BefehleAusfuehren;
  until (Aufgabe = BefehlEnde);
end.

