
{Datei: C:\Pascal\Progs6\DigiBahn.Pas }
{TurboPascal 7.0 Programm zur Modelleisenbahn-Steuerung}

Program DigiBahn;
{Manfred Fischer, Heroldstr. 44, D-48163 Mnster, den 24.08.1994}
{04.09.1994 ====== mit Mehrfachtraktion}
{05.10.1994 =1.00= mit Lokprogrammen}
{22.10.1994 =1.01= Nothaltfreigabe bei Kurzschlu}
{31.12.1994 =1.02= mit Magnetartikelsteuerung vom Lokprogramm aus}
{01.01.1995 ====== mit Digitaldrehkran und Spur-1-Loks (5 Funktionen)}
{04.01.1995 ====== mit Auswertung von Rckmeldemodulen von Lokprogs. aus}
{04.02.1995 =1.03= mit GBS und komplexer Magnetartikelsteuerung}
{12.02.1995 ====== Debugging vorlufig abgeschlossen}
{18.02.1995 ====== MagnetSchaltdauer in Lok-Progs ndern}
{26.02.1995 ====== Debugging}
{18.03.1995 ====== 5*Digital-Decoder sofort stoppen mittels Umschalten}
{26.03.1995 ====== GBS-Anzeige auch bei Herc. und CGA (globale Var. NurGBS)}
{16.06.1995 =1.04= Rckm.Mod. Fehler beseitigt}
{25.06.1995 ====== PortError Anzeige bei TimeOut, Zeitverzgerung debugged}
{09.07.1995 ====== Praesentieren der vorhandenen Fahrzeuge debugged}
{12.07.1995 ====== bei AllesStop nur die Loks anhalten, die nicht schon stehen}

Uses ScreenIO, BigText1, RollMenu, Digital;

{aus System werden verwendet: UpCase(), ParamCount, ParamStr()}

Const VersionNr : String[4] = '1.04';
      LokDateiName : String[12] = 'LOKDATEI.';
      ProgDateiName : String[12] = 'LOKPROGS.';
      GBSDateiName : String[12] = 'GBSDATEI.';
      InterfaceComPort : Byte = 1; {COM1: als Voreinstellung}
      MaxComPorts = 4; {unabhngig von der Hardware-Verfgbarkeit}
      TimeOutMessage = 'TimeOut trat auf';

Const Black  = 0;  {Farben analog zur TP-Unit Crt}
      Blue   = 1;
      Green  = 2;
      Cyan   = 3;
      Red    = 4;
      Magenta= 5;
      Yellow = 14;
      White  = 15;
      Blink  = 16;

      MenuLeisteStift = Yellow;
      MenuLeistePapier= Magenta;
      DesktopColor = Green; {Farbe des Hintergrunds der Arbeitsflche}

Type FileNameType = String[64]; {maximal sinnvolle Lnge fr Dateinamen unter DOS}
     String5 = String[5];
     String70 = String[70];


Function CToB(Ch : Char) : Byte; {Char To Byte}
begin
  CToB := Ord(Ch) - Ord('0');
end;

Function BToC(B : Word) : Char; {Byte To Char}
begin
  BToC := Chr((B MOD 10) + Ord('0'));
end;

Function WToS(W : Word; Laenge : Byte) : String5; {Word To String}
begin
  WToS := Copy(BToC(W DIV 10000) + BToC(W DIV 1000) + BToC(W DIV 100)
               + BToC(W DIV 10) + BToC(W MOD 10), 6 - Laenge, Laenge);
end;


Procedure DigitalSchalter(Delta : Boolean); {Mrklin Digitaldecoder-Schalterstellungen}
Const x0Digital = 34; x0Delta = 35;
      y0Digital = 13; y0Delta = 14;
      Breite = 24;
      Hoehe = 6;
      XPosAdr = 11; {relativ zu x0+1}
      YPosAdr = 1; {relativ zu y0+1}
      XPosCod = 1; {relativ zu x0+1}
      YPosCod = 3; {relativ zu y0+1}
      XPosTxt = 1; {relativ zu x0+1}
      YPosTxt = 6; {relativ zu y0+1}

Type ProgrammMode = (AdresseEingeben,SchalterEingeben);

Var x0, y0 : Word;
    Ch : Char;
    Adresse : Byte;
    AnzSchalter : Byte;
    Mode : ProgrammMode;
    EingabeAbgeschlossen : Boolean;
    S : String8;
    OldWindMax, OldWindMin : Word;

  Procedure SchalterRahmen(x0, y0 : Word);
  Var Loop : Word;
  begin
    WriteXY(x0,y0,LOC);
    for Loop := 1 to Pred(AnzSchalter) do write(WAC,TDC);
    write(WAC,ROC);
    WriteXY(x0,Succ(y0),SEC);
    for Loop := 1 to AnzSchalter do write('-',SEC);
    WriteXY(x0,y0+2,LUC);
    for Loop := 1 to Pred(AnzSchalter) do write(WAC,TUC);
    write(WAC,RUC);
    WriteXY(x0+1,y0,'on');
  end;

  Procedure SchalterStellung(x0, y0 : Word; Adresse : Byte);
  Var Loop : Word;
      S : String8;
  begin
    if Delta then
    begin
      if not IsDeltaAdresse(Adresse) then S := '????'
      else S := Adresse2DeltaSchalter(Adresse);
    end
    else {Digital-Decoder}
    begin
      if (Adresse in [LokAdresseMin..LokAdresseMax])
      then S := Adresse2DigitalSchalter(Adresse)
      else {gibt es nicht} S := '????????';
    end;
    for Loop := 1 to AnzSchalter do
      WriteXY(x0 + (Loop * 2) - 1,Succ(y0),S[Loop]);
  end;

  Procedure AdresseAnzeigen(x0,y0 : Word; Adresse : Byte);
  begin
    if (Adresse > LokAdresseMax) then WriteXY(x0,y0,'  ')
    else WriteXY(x0,y0,WToS(Adresse,2));
  end;

  Procedure TextAnzeigen(x0,y0 : Word; Adresse : Byte);
  Var S : TString;
  begin
    S := Adresse2DigitalText(Adresse);
    if ((S = '') and (Adresse >= LokAdresseMin))
    or Delta then S := Adresse2DeltaText(Adresse);
    WriteXY(x0,y0,S);
    write(' ':21 - Length(S));
  end;

  Procedure Anzeige(Adresse : Byte);
  begin
    SchalterStellung(XPosCod,YPosCod,Adresse);
    AdresseAnzeigen(XPosAdr,YPosAdr,Adresse);
    TextAnzeigen(XPosTxt,YPosTxt,Adresse);
  end;

  Procedure ChangeMode(NeuerMode : ProgrammMode);
  begin
    Mode := NeuerMode;
    EingabeAbgeschlossen := TRUE;
    if Mode = AdresseEingeben then
    begin
      Farben(Black,-1);
      WriteXY(1,YPosAdr,'Adresse');
      Farben(Yellow,-1);
      WriteXY(XPosCod+1,YPosCod,'on');
    end
    else
    begin
      Farben(Yellow,-1);
      WriteXY(1,YPosAdr,'Adresse');
      Farben(Black,-1);
      WriteXY(XPosCod+1,YPosCod,'on');
    end;
    Anzeige(Adresse);
  end;

begin
  if Delta then
  begin
    x0 := x0Delta; y0 := y0Delta;
    AnzSchalter := 4; {Delta-Decoder m6603}
  end
  else
  begin
    x0 := x0Digital; y0 := y0Digital;
    AnzSchalter := 8; {alle Digital-Decoder}
  end;
  RetteFensterGrenzen(OldWindMin,OldWindMax);
  Farben(Yellow,Cyan);
  MakeFenster(Pred(x0),Pred(y0),x0 + Breite,y0 + Hoehe,1);
  WriteXY(x0,y0 + Hoehe,'<ESC> zurck');
  Window(x0,y0,Pred(x0 + Breite),Pred(y0 + Hoehe));
  SchalterRahmen(XPosCod,YPosCod);
  ChangeMode(AdresseEingeben);
  repeat
    Ch := EineAuswahlTaste;
    case Ch of
      '0'..'9' : begin
              if (Ch = '0') or (Ch = '9')
              or (Delta and (Ch in ['5'..'9'])) then
              begin
                if Mode <> AdresseEingeben then ChangeMode(AdresseEingeben);
              end;
              if Mode = AdresseEingeben then
              begin
                if EingabeAbgeschlossen then Adresse := CToB(Ch)
                else Adresse := (Adresse * 10) + CToB(Ch);
                EingabeAbgeschlossen := not EingabeAbgeschlossen; {nur 2-stellige Adressen erlaubt}
                Anzeige(Adresse);
              end
              else
              begin
                if Delta then S := Adresse2DeltaSchalter(Adresse)
                else S := Adresse2DigitalSchalter(Adresse);
                if (S[CToB(Ch)] = '-') or (S[CToB(Ch)] = '?') then
                  S[CToB(Ch)] := Ch
                else S[CToB(Ch)] := '-';
                if Delta then Adresse := DeltaSchalter2Adresse(S)
                else Adresse := DigitalSchalter2Adresse(S);
                Anzeige(Adresse);
              end;
            end;
      'A' : ChangeMode(AdresseEingeben);
      'C','O' : ChangeMode(SchalterEingeben);
      else {alle anderen Tasten keine Aktion};
    end;
  until (Ch = EscapeKey);
  SetzeFensterGrenzen(OldWindMin,OldWindMax);
end; {DigitalSchalter}


Const MaxZuege = 160; {mehr ist nicht sinnvoll, 80 Loks + 80 Funktionsmodelle}
      MaxMagnet = 256; {gezhlt von 1 bis 256}
      MaxKontrolls = 15; {mehr geht z.Zt. nicht}
      MaxGBSX = 38; {gezhlt von 0}
      MaxGBSY = 10; {gezhlt von 0, das d.h. 429 GBS-Elemente}
      MinGBS = 0; {Beginn der Zhlung bei 0}
      MaxGBS = Pred(Succ(MaxGBSX) * Succ(MaxGBSY)); {gezhlt von 0}

      MaxZugProgs = MaxZuege; {gezhlt von 1..160}
      MaxGBSProgs = Succ(MaxGBS) * 3; {3 Zustnde, gezhlt von 1..1257}
      MaxProgs = MaxZugProgs + MaxGBSProgs; {gezhlt von 1}

      KranDrehen = TRUE;
      LastAufAb = TRUE;

Type FahrzeugArten = (KonventionelleLok,KonventionellerAnhaenger,
                      DigitalLok,DeltaLok,Spur1DigitalLok,
                      DigitalKran,FunktionsModell);
     LokFunktionsType = (Ohne,Telex,Licht);
     PFahrzeug = ^FahrzeugType;
     FahrzeugType = Record
       Nummer : 0..LokAdresseMax;         {Digitaladressen 1..80; 0 = konv.}
       Name : String[25];                 {beliebiger Text}
       Gattung : FahrzeugArten;           {Art des Fahrzeugs}
       Stunden, Minuten, Sekunden : Byte; {Betriebszeit}
       ProgrammPosition : Integer;        {Position im Fahrzeugprogramm}
       {0: inaktiv; positive Zahl: aktuelle Zeile; negative Zahl: aktuelle Zeile, aber z.Zt. unterbrochen}
       Next : PFahrzeug;                  {Verknpfung zur Mehrfachtraktion}
       {Lok- und Kranparameter}
       Geschwindigkeit : Byte;            {momentane V, Loks}
       ZielGeschwindigkeit : Byte;        {angestrebte V, Loks}
       StartVerzoegerung,
       BremsVerzoegerung : Byte;          {lineare Verzgerung, in Sekunden}
       AktionStart : Integer;             {Sekundenspeicher, zur Kontrolle der Verzgerung}
       LokFunktion : LokFunktionsType;    {Licht, Telex, Rauch etc.}
       LokFunktionAn : Boolean;           {ob eingeschaltet ist}
       FunktionAendern : Boolean;         {ob gendert werden soll}
       Richtung : Boolean;                {Fahrtrichtung}
       {Funktionsmodell-, Kran- und Spur-1-LokParameter}
       ModellFunc : array[Fmin..Fmax] of Boolean; {1..4}
       ModellFuncAendern : Boolean;       {ob gendert werden soll}
     end;
     ProgBefehl = (Nichts,Zeitverzoegerung,GotoBefehl,BeepBefehl,
                   GBSRot,GBSGruen,GBSZusatz,
                   Fahrtstufe,Anhalten,Richtungswechsel,
                   AnFunktion,AusFunktion,DrehFunktion,AufAbFunktion,
                   MagRot,MagGruen,MagSchaltdauer,
                   RueckmeldungEin,RueckmeldungAus);
     PLokProgramm = ^LokProgramm;
     LokProgramm = Record
        ZeilenNr : Word;
        Befehl : ProgBefehl;
        Parameter, Parameter2 : Integer;
        Next : PLokProgramm;
     end;
     MagnetStellungen = (Rot, Gruen, Zusatz, Belassen);
     PMagnet = ^MagnetType;
     MagnetType = Record
       Nummer : 0..255; {entspricht Adressen 256,1..255}
       Stellung : MagnetStellungen;
       ZielStellung : MagnetStellungen;
       SchaltDauer : Word; {in Millisekunden}
     end;
     GBSElementArt = (KeinSchalter, WechselSchalter, DreifachSchalter);
     GBSElementZustand = Record
       Darstellung : array[1..4] of Char;
       Farbe : array[1..4] of Byte;
     end;
     GBSElement = Record
       Art : GBSElementArt;
       Status : MagnetStellungen;
       MagnetReferenz : Integer; {-1 := keine Referenz zu Magnetartikel}
       ProgrammPosition : Integer;        {Position im Weichenprogramm}
       {0: inaktiv; positive Zahl: aktuelle Zeile; negative Zahl: aktuelle Zeile, aber z.Zt. unterbrochen}
       Zustaende : array[Rot..Zusatz] of GBSElementZustand;
     end;

Const ProgBefehlTxt : array[ProgBefehl] of String[18]
      = ('.','Zeitverzgerung','Goto','Beep',
         'GBS-Element Rot','GBS-Element Grn','GBS-Element Zusatz',
         'Fahrtstufe','Halt','Umschalten',
         'Einschalten','Ausschalten','Kran drehen','Last auf/ab',
         'Rot','Grn','Schaltdauer',
         'Rckmeldung Ein','Rckmeldung Aus');
Var Zug : array[1..MaxZuege] of PFahrzeug;
    ZugProg : array[1..MaxProgs] of PLokProgramm;
    Magnet : array[1..MaxMagnet] of PMagnet;
    Kontrolls : array[1..MaxKontrolls] of 0..MaxZuege;
    GBS : array[0..MaxGBS] of GBSElement;
    ProgrammEnde, AenderungenSpeichern, MitGBS, NurGBS : Boolean;
    OldSec, ProgSec : Word; {Sekundenspeicher}
    AktuKontroll, AktuGBS : Word;
    NothaltSteht, NothaltTaste, AllesStop, FreigabeTaste : Boolean;
    MenuUebersicht : RollMenuType;
    MenuFahrzeuge : RollMenuType;
    MenuProgEdit : RollMenuType;
    MenuElementeAendern : RollMenuType;


Procedure MenuLeiste;
var Leiste : String[80];
begin
  Farben(MenuLeisteStift,MenuLeistePapier);
  LoescheZeile(1);
  Leiste := ' alles Stop  Nothalt';
  if NothaltSteht then Leiste := Leiste + 'freigabe';
  Leiste := Leiste + '  Menu  Quit ';
  if AenderungenSpeichern then Leiste := Leiste + ' Infos sichern'
  else Leiste := Leiste + ' Infos vergessen';
  if MitGBS then Leiste := Leiste + '  Weichenfeld aus'
  else Leiste := Leiste + '  Weichenfeld an';
  WriteWithButtons(Leiste);
end;

Procedure LoescheDesktop;
begin
  Farben(-1,DesktopColor);
  LoescheBildschirm;
  MenuLeiste;
end;

Procedure Message(Txt : String70);
begin
  WriteXY(1,25,Txt);
  Beep;
end;


Procedure InitBildschirm;
begin
  RollMenuInit(MenuUebersicht,30,2,14,35);
  RollMenuAppend(MenuUebersicht,'PC-Schnittstelle: COM'+Chr(InterfaceComPort + Ord('0'))+':');
  RollMenuAppend(MenuUebersicht,'Fahrzeug-Wechsel');
  RollMenuAppend(MenuUebersicht,'Neues Fahrzeug einfgen');
  RollMenuAppend(MenuUebersicht,'Doppel-/Mehrfachtraktion');
  RollMenuAppend(MenuUebersicht,'Mehrfachtraktion AUS');
  RollMenuAppend(MenuUebersicht,'Fahr-Programm ndern');
  RollMenuAppend(MenuUebersicht,'Fahr-Programm AUS');
  RollMenuAppend(MenuUebersicht,'Nothaltfreigabe (Kurzschlu)');
  RollMenuAppend(MenuUebersicht,'Digitalschalter-Rechner');
  RollMenuAppend(MenuUebersicht,'Deltaschalter-Rechner');
  RollMenuAppend(MenuUebersicht,'GBS-Element ndern');
  RollMenuAppend(MenuUebersicht,'Programmende');

  RollMenuInit(MenuFahrzeuge,34,5,15,40);

  RollMenuInit(MenuElementeAendern,34,14,6,35);
  RollMenuAppend(MenuElementeAendern,'Zeichen/Farben ndern    ');
  RollMenuAppend(MenuElementeAendern,'Weichenfahrstrae   ROT  ');
  RollMenuAppend(MenuElementeAendern,'Weichenfahrstrae   GRN ');
  RollMenuAppend(MenuElementeAendern,'Weichenfahrstrae  ZUSATZ');

  LoescheDesktop;
end;

Procedure InitUhr;
begin
  OldSec := SekundenZeiger;
  ProgSec := OldSec;
end;

Procedure InitZug(P : PFahrzeug); {ein einzelnes Fahrzeug auf 0 setzen}
begin
  if (P <> NIL) then with P^ do
  begin
    Nummer := DeltaKonventionellAdresse;
    Name := '';
    Gattung := KonventionellerAnhaenger;
    Stunden := 0; Minuten := 0; Sekunden := 0;
    ProgrammPosition := 0;  {inaktiv}
    Next := NIL;     {keine Mehrfachtraktion z.Zt.}
    Geschwindigkeit := Vstop;
    ZielGeschwindigkeit := Vstop;
    StartVerzoegerung := 0;
    BremsVerzoegerung := 0;
    AktionStart := -1;
    LokFunktion := Ohne;
    LokFunktionAn := FALSE;
    FunktionAendern := FALSE;
    Richtung := FALSE;
    ModellFunc[1] := FALSE; ModellFunc[2] := FALSE;
    ModellFunc[3] := FALSE; ModellFunc[4] := FALSE;
    ModellFuncAendern := FALSE;
  end;
end;

Procedure InitGBSElement(Nummer : Word); {ein einzelnes Element}
Var M : MagnetStellungen;
    i : Byte;
begin
  with GBS[Nummer] do
  begin
    Art := KeinSchalter;
    Status := Belassen;
    MagnetReferenz := -1;
    ProgrammPosition := 0;
    for M := Rot to Zusatz do with Zustaende[M] do
      for i := 1 to 4 do
      begin
        Darstellung[i] := ' '; {SPACE}
        Farbe[i] := Black;
      end;
  end;
end;

Procedure InitSpeziellesGBSElement(Nummer : Word; Symbol : Char);
begin    {ohne Schaltfunktion}
  InitGBSElement(Nummer);
  with GBS[Nummer] do
  begin
    case Symbol of
      '-' : begin {horizontal}
              Zustaende[Rot].Darstellung[1] := '_';
              Zustaende[Rot].Darstellung[2] := '_';
      end;
      '/' : begin {steigend}
              Zustaende[Rot].Darstellung[2] := '/';
              Zustaende[Rot].Darstellung[3] := '/';
      end;
      '\' : begin {fallend}
              Zustaende[Rot].Darstellung[1] := '\';
              Zustaende[Rot].Darstellung[4] := '\';
      end;
    end;
  end;
end;


Procedure InitSchnittstelle;
begin
  SetComPort(InterfaceComPort);
  SetMagnetDelay(150); {Millisekunden, der von Mrklin empfohlene Idealwert}
  DigitalInterfaceInit; {Baudrate etc.}
end;

Procedure NotHaltFreigabeBeiKurzschluss;
begin
  FreigabeTaste := TRUE;
end;


Procedure MenuFahrzeugeErweitern(P : PFahrzeug);
{verlngert das Menu "Anzeige der vorhandenen Fahrzeuge" um eines}
Var S : RollMenuInhaltType;
begin
  S := P^.Name;
  if (Length(S) > 21) then S := Copy(S,1,19) + '..'
  else while (Length(S) < 21) do S := S + ' ';
  S := S + ' ' + WToS(P^.Nummer,2) + ' ';
  case P^.Gattung of
    DigitalLok : if (P^.LokFunktion = Telex) then S := S + 'Telex';
    DeltaLok   : S := S + 'Delta';
    DigitalKran: S := S + 'Kran';
    FunktionsModell : S := S + 'FuncM';
    Spur1DigitalLok : S := S + '5Func';
  end;
  RollMenuAppend(MenuFahrzeuge, S);
end;


Function NeueLokEinfuegen : Byte;
Const x0 = 17;
      y0 = 10;
      Breite = 62;
      Hoehe = 9;
Var Loop : 1..Succ(MaxZuege);
    Ch : Char;
    OldWindMin, OldWindMax : Word;
    NeuePosition : Byte;

begin
  RetteFensterGrenzen(OldWindMin,OldWindMax);
  Farben(Yellow,Cyan);
  MakeFenster(Pred(x0),Pred(y0),x0 + Breite,y0 + Hoehe,2);
  Window(x0,y0,Pred(x0 + Breite),Pred(y0 + Hoehe));
  Farben(White,-1); writeln('Neue Lok/Funkt.-Modell einfgen');
  Farben(Black,-1);
  NeuePosition := 0;
  Loop := 1;
  while (Loop <= MaxZuege) and (Zug[Loop] <> NIL) do Inc(Loop);
  if (Loop > MaxZuege) then Message('Liste ist voll, kein Eintrag mglich.')
  else
  begin
    NeuePosition := Loop;
    New(Zug[Loop]);
    InitZug(Zug[Loop]);
    with Zug[Loop]^ do
    begin
      write('Digitaladresse (0,1..80):  '); readln(Nummer);
      write('Name (max. 25 Zeichen):    '); readln(Name);
      WriteWithButtons('Ohne Digitallok dElta Funktionsmodell Kran Spur-1');
      Ch := EineAuswahlTaste;
      if (Ch in ['D','E','K','S']) then
      begin
        writeln;
        write('linear Startverzgert [sec]: ');
        readln(StartVerzoegerung);
        write('linear Bremsverzgert [sec]: ');
        readln(BremsVerzoegerung);
      end;
      case Ch of
        'O' : begin
                Gattung := KonventionellerAnhaenger;
                Nummer := DeltaKonventionellAdresse;
              end;
        'D','S' : begin
                if (Ch = 'S') then Gattung := Spur1DigitalLok
                else Gattung := DigitalLok;
                WriteWithButtons('func:  Ohne  Telex  Licht');
                case EineAuswahlTaste of
                  'T' : LokFunktion := Telex;
                  'L' : LokFunktion := Licht;
                  else LokFunktion := Ohne;
                end;
              end;
        'E' : begin
                Gattung := DeltaLok;
                LokFunktion := Licht;
              end;
        'F' : Gattung := FunktionsModell;
        'K' : begin
                Gattung := DigitalKran;
                LokFunktion := Licht;
              end;
        else
        begin
          Message('Eingabe abgebrochen.');
          Dispose(Zug[Loop]);
          Zug[Loop] := NIL;
          NeuePosition := 0;
        end;
      end;
    end;
  end;
  SetzeFensterGrenzen(OldWindMin,OldWindMax);
  Farben(-1,DesktopColor);
  MakeFenster(Pred(x0),Pred(y0),x0 + Breite,y0 + Hoehe,0);
  NeueLokEinfuegen := NeuePosition;
end;


Procedure ProgrammEdit(LokNr : Word); {fr Loks und GBS-Elemente}
Const x0 = 8; {absolute Korrdinaten}
      y0 = 5;
      Breite = 72;
      Hoehe = 20;
      XTexte = 44;
      YTexte = 7;
      XEdit = 8;
      YEdit = 7;
      BEdit = 36; {Breite der Editflche}
      HEdit = 17; {Hoehe der Editflche}

Type String7 = String[7];
     String40 = String[40];

Var Ch : Char;
    OldWindMin, OldWindMax : Word;
    Loop, Count, AktuZeile : Word;
    Z : PLokProgramm;
    RollZeile : PRollMenuZeile;
    GueltigeBefehlsTasten : Set of Char; {was der Benutzer eingeben darf}
    PProgrammPosition : ^Integer;

    Function WToP(W : Word; Laenge : Byte) : String7;
    begin
      WToP := '(' + WToS(W,Laenge) + ')';
    end;

    Function ProgZeileKlartext(Zeiger : PLokProgramm) : String;
    Var S : String;
    begin
      if (Zeiger = NIL) then S := 'Fehler'
      else
      begin
        S := WToS(Zeiger^.ZeilenNr,4)+': '+ProgBefehlTxt[Zeiger^.Befehl];
        case Zeiger^.Befehl of
          Zeitverzoegerung,
          MagSchaltdauer :   S := S + WToP(Zeiger^.Parameter,4);
          GotoBefehl :       S := S + WToP(Zeiger^.Parameter,4);
          GBSRot,GBSGruen,
          GBSZusatz :        S := S + WToP(Zeiger^.Parameter,3);
          Fahrtstufe :       S := S + WToP(Zeiger^.Parameter,2);
          AnFunktion,
          AusFunktion : if (Zeiger^.Parameter in [1..4]) then
                             S := S + WToP(Zeiger^.Parameter,1);
          MagRot,MagGruen,RueckmeldungEin,
          RueckmeldungAus :  S := S + WToP(Zeiger^.Parameter,3);
        end;
      end;
      ProgZeileKlartext := S;
    end;

    Function NeueProgZeile(var Start : PLokProgramm; Index : Word) : PLokProgramm;
    {vor Index-te Position davorfgen}
    var Loop : Word;
        P, Zeiger : PLokProgramm;
    begin
      if (Start = NIL) then
      begin
        New(Start);
        Start^.ZeilenNr := 1;
        Start^.Befehl := Nichts;
        Start^.Parameter := 0;
        Start^.Parameter2 := 0;
        Start^.Next := NIL;
        NeueProgZeile := Start;
      end
      else
      begin
        New(Zeiger);
        Zeiger^.ZeilenNr := Index;
        Zeiger^.Befehl := Nichts;
        Zeiger^.Parameter := 0;
        Zeiger^.Parameter2 := 0;
        if (Index = 1) then
        begin
          Zeiger^.Next := Start;
          Start := Zeiger;
        end
        else
        begin
          P := Start;
          for Loop := 1 to (Index - 2) do P := P^.Next;
          Zeiger^.Next := P^.Next;
          P^.Next := Zeiger;
        end;
        P := Zeiger^.Next;
        while (P <> NIL) do
        begin
          P^.ZeilenNr := Succ(P^.ZeilenNr);
          P := P^.Next;
        end;
        NeueProgZeile := Zeiger;
      end;
    end;

    Procedure EntferneProgZeile(var Start : PLokProgramm; Index : Word);
    Var P, H : PLokProgramm;
        Loop : Word;
    begin
      if (Start <> NIL) then
      begin
        if (Index = 1) then
        begin
          H := Start^.Next;
          Dispose(Start);
          Start := H;
        end
        else
        begin
          P := Start;
          for Loop := 1 to (Index - 2) do
          if (P^.Next <> NIL) then P := P^.Next;
          H := P^.Next^.Next;
          Dispose(P^.Next);
          P^.Next := H;
        end;
        while (H <> NIL) do
        begin
          H^.ZeilenNr := Pred(H^.ZeilenNr);
          H := H^.Next;
        end;
      end;
    end;

    Function IndexProgZeile(Start : PLokProgramm; Index : Word) : PLokProgramm;
    Var Loop : Word;
        P : PLokProgramm;
    begin
      P := Start;
      for Loop := 2 to Index do if (P <> NIL) then P := P^.Next;
      IndexProgZeile := P;
    end;

    Procedure WriteTxt(Y : Word; S : String40);
    begin
      WriteXY(XTexte,YTexte + Y,S);
    end;

    Function GrenzenTest(Parameter, Min, Max : Integer; Ch : Char) : Integer;
    begin
      if (Parameter < Min) or (Parameter > Max) then GrenzenTest := CToB(Ch)
      else GrenzenTest := (Parameter * 10) + CToB(Ch);
    end;

begin
  RetteFensterGrenzen(OldWindMin,OldWindMax);
  Farben(Yellow,Cyan);
  MakeFenster(Pred(x0),Pred(y0),x0 + Breite,y0 + Hoehe,2);
  WriteXY(x0,y0 + Hoehe,'<ESC> zurck');
  Farben(White,-1);
  if (LokNr <= MaxZuege) then
  begin
    WriteXY(x0,y0,  'Fahrtprogramm fr: ' + Zug[LokNr]^.Name);
    WriteXY(x0,y0+1,'Digitaladresse:    ' + WToS(Zug[LokNr]^.Nummer,2));
    PProgrammPosition := Addr(Zug[LokNr]^.ProgrammPosition);
  end
  else {GBS-Element}
  begin
    Count := (LokNr - MaxZuege - 1) DIV 3;
    WriteXY(x0,y0,'Programm fr GBS-Element: '+ WToS(Count,3) + ' Stellung: ');
    case (LokNr - MaxZuege - 1) MOD 3 of
      0 : write('ROT');
      1 : write('GRN');
      2 : write('ZUSATZ');
    end;
    WriteXY(x0,y0+1,'Referenz zu Magnetartikel:  ');
    with GBS[Count] do
    if (MagnetReferenz < 0) then write('ohne')
    else write(MagnetReferenz);
    PProgrammPosition := Addr(GBS[Count].ProgrammPosition);
  end;
  write('    Prog-Pos: ',WToS(Abs(PProgrammPosition^),4));
  if (PProgrammPosition^ > 0) then
  begin
    Z := IndexProgZeile(ZugProg[LokNr],PProgrammPosition^);
    if (Z <> NIL) then
    begin
      case Z^.Befehl of
        Zeitverzoegerung : write('  Zeitverzgerung: ',Z^.Parameter2,'sec');
        RueckmeldungEin : write('  warten auf Kontakt ',Z^.Parameter,' EIN');
        RueckmeldungAus : write('  warten auf Kontakt ',Z^.Parameter,' AUS');
      end;
    end;
  end
  else if (PProgrammPosition^ < 0) then write('  z.Zt. unterbrochen');
  Farben(White,-1);
  WriteTxt(0,'Befehlsbersicht:');
  WriteTxt(1,'<.> nichts tun');
  WriteTxt(2,'go<T>o(..Zeilen-Nr..)');
  WriteTxt(3,'<Z>eitverzgerung(..in Sek..)');
  if (LokNr <= MaxZuege) then
  begin
    if (Zug[LokNr]^.Gattung = FunktionsModell) then
    begin
      WriteTxt(4,'Funktion <E>inschalten(..Nr..)');
      WriteTxt(5,'Funktion <A>usschalten(..Nr..)');
      WriteTxt(6,'   Nr liegt im Bereich 1..4');
    end
    else
    begin
      WriteTxt(4,'<F>ahrtstufe(..Zahl..)');
      WriteTxt(5,'<H>alt');
      WriteTxt(6,'<U>mschalten der Richtung');
      if (Zug[LokNr]^.Gattung = DigitalKran) then
      begin
        WriteTxt(7,'<K>ran drehen, <L>ast auf/ab');
        WriteTxt(8,'Licht/Magnet <E>in bzw. <A>us');
      end
      else
      begin
        WriteTxt(7,'Lokfunktion <E>inschalten');
        WriteTxt(8,'Lokfunktion <A>usschalten');
      end;
    end;
  end
  else {GBS-Element}
  begin
    WriteTxt(4,'<B>eep');
    WriteTxt(5,'GBS-Element schalten R<O>t(..Nr..)');
    WriteTxt(6,'GBS-Element schalten Gr<>n(..Nr..)');
    WriteTxt(7,'GBS-Element schalten Zu<S>atz(..Nr..)');
    WriteTxt(8,'   Nr liegt im Bereich 0..428');
  end;
  WriteTxt(9,'Magnet schalten <R>ot(..Nr..)');
  WriteTxt(10,'Magnet schalten <G>rn(..Nr..)');
  WriteTxt(11,'   Nr liegt im Bereich 1..256');
  WriteTxt(12,'schalt<D>auer(..Millisekunden..)');
  WriteTxt(13,'<W>arten Rckmeldung Ein(..Nr..)');
  WriteTxt(14,'warte<N> Rckmeldung Aus(..Nr..)');
  WriteTxt(15,'   Nr liegt im Bereich 1..496');

  WriteTxt(16,'<INS> Befehlszeile einfgen');
  WriteTxt(17,'<DEL> Befehlszeile lschen');

  WriteXY(XEdit+BEdit-2,YEdit+1,PfeilNachOben);
  WriteXY(XEdit+BEdit-2,YEdit+HEdit-2,PfeilNachUnten);
  for Loop := YEdit+2 to YEdit+HEdit-3 do
    WriteXY(XEdit+BEdit-2,Loop,SEC);

  RollMenuInit(MenuProgEdit,XEdit,YEdit,HEdit,BEdit);
  Z := ZugProg[LokNr];
  Count := 0;
  while (Z <> NIL) do
  begin
    Inc(Count);
    RollMenuAppend(MenuProgEdit,ProgZeileKlartext(Z));
    Z := Z^.Next;
  end;
  RollMenuAppend(MenuProgEdit,'ENDE:');
  RollMenuShow(MenuProgEdit);
  AktuZeile := 1;
  GueltigeBefehlsTasten := ['.','Z','T','B','O','','','S','R','G','D','W','N'];
  if (LokNr <= MaxZuege) then
    GueltigeBefehlsTasten := GueltigeBefehlsTasten + ['F','H','U','E','A','K','L'];
  repeat
    if ReadUpCaseKey(Ch) then  {Funktionstaste}
    begin
      case Ch of
        InsertKey : if (Count < 1000) then
              begin {Insert}
                Ch := NullKey;
                Z := NeueProgZeile(ZugProg[LokNr],AktuZeile);
                Inc(Count);
                RollMenuInsert(MenuProgEdit,AktuZeile,ProgZeileKlarText(Z));
              end
              else Message('nicht mehr als 1000 Zeilen mglich');
        DeleteKey : begin {Delete}
                Ch := NullKey;
                EntferneProgZeile(ZugProg[LokNr],AktuZeile);
                Dec(Count);
                RollMenuDelete(MenuProgEdit,AktuZeile);
              end;
        UpKey : if (AktuZeile > 1) then Dec(AktuZeile);
        DownKey : if (AktuZeile <= Count) then Inc(AktuZeile);
      end;
    end
    else  {normale Taste}
    begin
      if (Ch in GueltigeBefehlsTasten) and (AktuZeile = Succ(Count)) then
      begin {neue Zeile am Ende anhngen}
        Z := NeueProgZeile(ZugProg[LokNr],AktuZeile);
        Inc(Count);
        RollMenuInsert(MenuProgEdit,AktuZeile,ProgZeileKlarText(Z));
      end
      else Z := IndexProgZeile(ZugProg[LokNr],AktuZeile); {Zeile suchen}

      if (Z <> NIL) then
      begin
        if (Ch in GueltigeBefehlsTasten) then
        begin
          Z^.Parameter := 0;
          Z^.Parameter2 := 0;
          if (Ch in ['E','A']) and (Zug[LokNr]^.Gattung = FunktionsModell)
          then Z^.Parameter := Fmin; {d.h. := 1}
        end;
        case Ch of
          '.' : Z^.Befehl := Nichts;
          'Z' : Z^.Befehl := Zeitverzoegerung;
          'T' : Z^.Befehl := GotoBefehl;
          'B' : Z^.Befehl := BeepBefehl;
          'O' : Z^.Befehl := GBSRot;
      '','' : Z^.Befehl := GBSGruen;
          'S' : Z^.Befehl := GBSZusatz;
          'F' : Z^.Befehl := FahrtStufe;
          'H' : Z^.Befehl := Anhalten;
          'U' : Z^.Befehl := Richtungswechsel;
          'E' : Z^.Befehl := AnFunktion;
          'A' : Z^.Befehl := AusFunktion;
          'K' : Z^.Befehl := DrehFunktion;
          'L' : Z^.Befehl := AufAbFunktion;
          'R' : Z^.Befehl := MagRot;
          'G' : Z^.Befehl := MagGruen;
          'D' : Z^.Befehl := MagSchaltdauer;
          'W' : Z^.Befehl := RueckmeldungEin;
          'N' : Z^.Befehl := RueckmeldungAus;
          '0'..'9' : with Z^ do begin {maximal 4-stellige Zahlen erlauben}
            case Befehl of
              Zeitverzoegerung, MagSchaltdauer :
                Parameter := GrenzenTest(Parameter,0,999,Ch);
              GotoBefehl : Parameter := GrenzenTest(Parameter,1,999,Ch);
              GBSRot,GBSGruen,GBSZusatz :
                Parameter := GrenzenTest(Parameter,MinGBS,MaxGBS,Ch);
              FahrtStufe :
                Parameter := GrenzenTest(Parameter,Vstop,Vmax,Ch);
              MagRot, MagGruen :
                Parameter := GrenzenTest(Parameter,MagnetAdresseMin,
                                         MagnetAdresseMax,Ch);
              RueckmeldungEin,RueckmeldungAus :
                Parameter := GrenzenTest(Parameter,RueckmeldeAdresseMin,
                                         RueckmeldeAdresseMax,Ch);
              AnFunktion, AusFunktion :
                if (Zug[LokNr]^.Gattung = FunktionsModell) then
                begin
                  if not (Ch in ['1'..'4']) then Parameter := Fmin
                  else Parameter := GrenzenTest(0,Fmin,Fmax,Ch)
                end
                else Parameter := 0;
              else Parameter := 0; {bei allen anderen Befehlen kein Parameter}
            end; {case}
          end;
        end; {case}
      end;
      if (Ch in (GueltigeBefehlsTasten + ['0'..'9'])) then Ch := NullKey;
    end;
    if (Ch = NullKey) then {mu die Anzeige erneuert werden}
    begin
      RollZeile := MenuProgEdit.Zeilen;
      Loop := 0;
      while (RollZeile <> NIL) do
      begin
        Inc(Loop);
        if (Loop > Count) then RollZeile^.Inhalt := 'ENDE:'
        else RollZeile^.Inhalt :=
          ProgZeileKlartext(IndexProgZeile(ZugProg[LokNr],Loop));
        RollZeile := RollZeile^.Next;
      end;
      RollMenuShow(MenuProgEdit);
    end;
    if (RollMenuAktion(MenuProgEdit,Ord(Ch)) <> 0) then;
  until (Ch = EscapeKey);

  for Loop := 1 to Count do RollMenuDelete(MenuProgEdit,Loop);
  SetzeFensterGrenzen(OldWindMin,OldWindMax);
  Farben(-1,DesktopColor);
  MakeFenster(Pred(x0),Pred(y0),x0 + Breite,y0 + Hoehe,0);
end;


Function BefehlsMenu : Boolean; {TRUE, wenn Hauptprogr. enden sol}
Const NotSelectedPressed = 0; {ReturnCodes von Function Praesentiere()}
      DeleteKeyPressed = -11;
var Rc : Integer;
    ProgrammQuit : Boolean;

  Procedure FensterVorbereiten(Menu : RollMenuType;
                               MitDelete, MitPfeilenRechts : Boolean);
  Var y1 : Word;
  begin
    with Menu do
    begin
      y1 := y0 + DownIndex - TopIndex + 2;
      MakeFenster(x0,y0,x0+Breite-1,y1,2);
      WriteXY(x0+1,y1,'<ESC> zurck');
      if MitDelete then write(';  <DEL> Eintrag lschen');
      if MitPfeilenRechts then
      begin
        WriteXY(x0+Breite-1,y0 + 1,PfeilNachOben);
        WriteXY(x0+Breite-1,y1 - 1,PfeilNachUnten);
      end;
    end;
  end;

  Function Praesentiere(var Menu : RollMenuType) : Integer;
  Var ReturnCode : Integer; {RC = 0 ==> not selected; RC > 0 ==> selected}
      Ch : Char;            {RC = -11 ==> selected for Delete}
  begin
    RollMenuShow(Menu);
    repeat
      if ReadUpCaseKey(Ch) then ; {Tastatur auswerten}
      ReturnCode := RollMenuAktion(Menu,Ord(Ch));
    until (ReturnCode <> 0) or (Ch in [EscapeKey,DeleteKey]);
    case Ch of
      DeleteKey : Praesentiere := DeleteKeyPressed;
      EscapeKey : Praesentiere := NotSelectedPressed;
      else Praesentiere := ReturnCode;
    end;
  end;

  Procedure FensterSchliessen(Menu : RollMenuType);
  begin
    with Menu do
    begin
      Farben(-1,DesktopColor);
      MakeFenster(x0,y0,x0+Breite-1,y0 + DownIndex - TopIndex + 2,0);
    end;
  end;

  Function LokAuswahl : Integer;
  Var Rc : Integer;
      PL : PLokProgramm;
  begin
    Farben(Yellow,Cyan);
    FensterVorbereiten(MenuFahrzeuge,TRUE,TRUE);
    Rc := Praesentiere(MenuFahrzeuge);
    if (Rc = DeleteKeyPressed) then {Delete}
    begin
      Rc := MenuFahrzeuge.AktuIndex;
      RollMenuDelete(MenuFahrzeuge,Rc);
      if (Zug[Rc] <> NIL) then Dispose(Zug[Rc]);
      Zug[Rc] := NIL;
      while (ZugProg[Rc] <> NIL) do
      begin
        PL := ZugProg[Rc]^.Next;
        Dispose(ZugProg[Rc]);
        ZugProg[Rc] := PL;
      end;
      ZugProg[Rc] := NIL;
      Rc := NotSelectedPressed;
    end;
    FensterSchliessen(MenuFahrzeuge);
    LokAuswahl := Rc;
  end;

  Procedure LokKontrollNeuBesetzen(LokNr : Integer);
  begin
    if (LokNr in [1..MaxZuege]) then
    begin
      if (AktuKontroll = 0) then AktuKontroll := 1;
      Kontrolls[AktuKontroll] := LokNr;
    end;
  end;

  Procedure FahrzeugEinsortieren(NeueLok : Integer);
  Var Loop : Integer;
  begin
    if (NeueLok > 0) then if (Zug[NeueLok] <> NIL) then {gltige Eingabe}
    begin
      MenuFahrzeugeErweitern(Zug[NeueLok]);
      Loop := 1;
      while (Loop <= MaxKontrolls) do
      begin
        if Kontrolls[Loop] = 0 then
        begin
          Kontrolls[Loop] := NeueLok;
          Loop := Succ(MaxKontrolls); {--> Stop While()}
        end
        else Inc(Loop);
      end;
    end;
  end;

  Procedure MehrfachtraktionMit(FrontLokKontroll : Word; NeueLok : Integer);
  Var PF : PFahrzeug;
  begin
    if (NeueLok in [1..MaxZuege])
    and (FrontLokKontroll in [1..MaxKontrolls])
    and (Zug[Kontrolls[FrontLokKontroll]] <> NIL) then
    begin
      PF := Zug[Kontrolls[FrontLokKontroll]];
      while (PF^.Next <> NIL) do PF := PF^.Next;
      PF^.Next := Zug[NeueLok];
    end;
  end;

  Procedure MehrfachtraktionAus(FrontLokKontroll : Word);
  Var PF, PF2 : PFahrzeug;
  begin
    if (FrontLokKontroll in [1..MaxKontrolls])
    and (Zug[Kontrolls[FrontLokKontroll]] <> NIL) then
    begin
      PF := Zug[Kontrolls[FrontLokKontroll]];
      while (PF^.Next <> NIL) do
      begin
        PF2 := PF^.Next;
        PF^.Next := NIL;
        PF := PF2;
      end;
    end;
  end;

  Procedure ElementeAendern;
  Const x0 = 30;
        y0 = 14;
        Breite = 49;
        Hoehe = 11;
  Var Loop : Byte;
      Rc : Integer;
      Ch : Char;
      OldWindMin, OldWindMax : Word;
      NeuePosition : Byte;

    Procedure EingabeZeichen(M : MagnetStellungen);
    Const PositionsNamen : array[1..4] of String[12] =
          ('Links oben','Rechts oben','Links unten','Rechts unten');
    Var i : Byte;
    begin
      write('4 Zeichen eingeben fr Symbol ');
      case M of
        Belassen : begin
          writeln(':');
          M := Rot; {wenn keine Alternative erlaubt, dann in ROT eintragen}
        end;
        Rot : writeln('ROTE Schalterstellung:');
        Gruen : writeln('GRNE Schalterstellung:');
        Zusatz : writeln('ZUSATZ Schalterstellung:');
      end;
      for i := 1 to 4 do
      begin
        write(PositionsNamen[i],': ');
        GBS[AktuGBS].Zustaende[M].Darstellung[i] := ReadKeyEcho;
        writeln;
      end;
      writeln('Farben (Werte 0..31) eingeben:');
      writeln('Schwarz=',Black,', Rot=',Red,' Grn=',Green,' Gelb=',Yellow);
      for i := 1 to 4 do
      begin
        write(PositionsNamen[i],': ');
        readln(GBS[AktuGBS].Zustaende[M].Farbe[i]);
      end;
    end;

  begin
    repeat
      Farben(Yellow,Cyan);
      FensterVorbereiten(MenuElementeAendern,FALSE,FALSE);
      Rc := Praesentiere(MenuElementeAendern);
      if (Rc < 0) then Rc := NotSelectedPressed;
      case Rc of
        1 : begin
              RetteFensterGrenzen(OldWindMin,OldWindMax);
              Farben(Yellow,Blue);
              MakeFenster(Pred(x0),Pred(y0),x0 + Breite,y0 + Hoehe,2);
              Window(x0,y0,Pred(x0 + Breite),Pred(y0 + Hoehe));
              Farben(White,-1); writeln('GBS-Element ndern Nr: ',AktuGBS);
              Farben(Yellow,-1);
              writeln('Schaltfunktion:');
              WriteWithButtons('Ohne  Wechselschalter  Dreifachschalter');
              Ch := EineAuswahlTaste;
              if (Ch in ['O','W','D']) then
              with GBS[AktuGBS] do
              begin
                InitGBSElement(AktuGBS);
                writeln;
                case Ch of
                  'O' : begin
                          Art := KeinSchalter;
                          EingabeZeichen(Belassen);
                        end;
                  'W','D' : begin
                          if (Ch = 'W') then
                          begin
                            Art := WechselSchalter;
                            write('Referenz zu einem Magnetartikel  ');
                            WriteWithButtons('Ja / Nein');
                            if (EineAuswahlTaste in ['J','Y']) then
                            begin
                              writeln;
                              write('Nummer des Magnetartikels: ');
                              readln(MagnetReferenz);
                            end
                            else writeln;
                          end
                          else Art := DreifachSchalter; {dann keine Referenz}
                          EingabeZeichen(Rot);
                          EingabeZeichen(Gruen);
                          if (Art = DreifachSchalter) then EingabeZeichen(Zusatz);
                        end;
                end; {case}
              end;
              SetzeFensterGrenzen(OldWindMin,OldWindMax);
              Farben(-1,DesktopColor);
              MakeFenster(Pred(x0),Pred(y0),x0 + Breite,y0 + Hoehe,0);
            end;
        2 : ProgrammEdit(MaxZuege + 1 + (AktuGBS * 3));
        3 : ProgrammEdit(MaxZuege + 2 + (AktuGBS * 3));
        4 : if (GBS[AktuGBS].Art = DreifachSchalter) then
              ProgrammEdit(MaxZuege + 3 + (AktuGBS * 3));
      end; {case}
    until (Rc = NotSelectedPressed);
    FensterSchliessen(MenuElementeAendern);
  end;

begin
  ProgrammQuit := FALSE;
  Farben(Yellow,Cyan);
  FensterVorbereiten(MenuUebersicht,FALSE,FALSE);
  repeat
    Rc := Praesentiere(MenuUebersicht);
    case Rc of
      1 : begin
            InterfaceComPort := Succ(InterfaceComPort MOD MaxComPorts);
            MenuUebersicht.Zeilen^.Inhalt[
                    Length(MenuUebersicht.Zeilen^.Inhalt)-1] :=
                       BToC(InterfaceComPort);
            InitSchnittstelle;
          end;
      2 : LokKontrollNeuBesetzen(LokAuswahl);
      3 : FahrzeugEinsortieren(NeueLokEinfuegen);
      4 : MehrfachtraktionMit(AktuKontroll,LokAuswahl);
      5 : MehrfachtraktionAus(AktuKontroll);
      6 : if (AktuKontroll in [1..MaxKontrolls])
          and (Zug[Kontrolls[AktuKontroll]] <> NIL) then
            ProgrammEdit(Kontrolls[AktuKontroll]);
      7 : if (AktuKontroll in [1..MaxKontrolls])
          and (Zug[Kontrolls[AktuKontroll]] <> NIL) then
            Zug[Kontrolls[AktuKontroll]]^.ProgrammPosition := 0;
      8 : NotHaltFreigabeBeiKurzschluss;
      9 : DigitalSchalter(FALSE);
     10 : DigitalSchalter(TRUE);
     11 : if MitGBS then ElementeAendern;
     12 : ProgrammQuit := TRUE;
    end;
  until (RC <> 1);
  FensterSchliessen(MenuUebersicht);
  BefehlsMenu := ProgrammQuit;
end;


Procedure ErsetzeDateiVersionen(AlteVersion, NeueVersion : FileNameType);
Var Datei : File;
begin
  Assign(Datei,AlteVersion);
  {$I-} Reset(Datei) {$I-};
  if (IOResult = 0) then     {alte Version lschen}
  begin
    Close(Datei);
    Erase(Datei);
  end;
  Assign(Datei,NeueVersion);
  Rename(Datei,AlteVersion); {neuer Version den alten Namen geben}
end;

Procedure LeseLokDatei;
Var Datei : File of FahrzeugType;
    Loop : 0..MaxZuege;
begin
  Assign(Datei,LokDateiName);
  {$I-} Reset(Datei) {$I+};
  if IOResult <> 0 then Message('Datei '+LokDateiName+' nicht gefunden.')
  else
  begin
    for Loop := 1 to MaxZuege do Zug[Loop] := NIL;
    Loop := 0;
    while not Eof(Datei) do
    begin
      Inc(Loop);
      New(Zug[Loop]);
      read(Datei,Zug[Loop]^);
      case Zug[Loop]^.Gattung of
        DigitalLok..DigitalKran : begin
          Zug[Loop]^.Geschwindigkeit := Vstop;
          Zug[Loop]^.AktionStart := -1;
        end;
      end;
      Zug[Loop]^.ProgrammPosition := 0; {alle Programme AUS}
      Zug[Loop]^.Next := NIL; {noch keine Verknuepfungen jetzt bitte}
      if (Loop <= MaxKontrolls) then Kontrolls[Loop] := Loop;
      MenuFahrzeugeErweitern(Zug[Loop]);
    end;
    Close(Datei);
  end;
end;

Procedure SchreibeLokDatei;
Var Datei : File of FahrzeugType;
    Loop : 0..MaxZuege;
begin
  Assign(Datei,LokDateiName+'NEU');
  {$I-} Rewrite(Datei) {$I+};
  if IOResult <> 0 then Message('Fehler beim Neuanlegen einer Datei.')
  else
  begin
    for Loop := 1 to MaxZuege do
    if (Zug[Loop] <> NIL) then if IOResult = 0 then
      {$I-} write(Datei,Zug[Loop]^) {$I+};
    {$I-} Close(Datei) {$I+};
    if IOResult <> 0 then Message('Fehler beim Schreiben einer Datei.')
    else ErsetzeDateiVersionen(LokDateiName,LokDateiName+'NEU');
  end;
end;


Procedure LeseLokProgDatei;
Var Datei : File of LokProgramm;
    Loop : 0..MaxProgs;
    PZeile, PP : PLokProgramm;
begin
  Assign(Datei,ProgDateiName);
  New(PZeile);
  {$I-} Reset(Datei) {$I+};
  if IOResult <> 0 then Message('Datei '+ProgDateiName+' nicht gefunden.')
  else
  begin
    for Loop := 1 to MaxProgs do
    begin
      ZugProg[Loop] := NIL;
      if not Eof(Datei) then read(Datei,PZeile^)
      else PZeile^.ZeilenNr := 0;
      if (PZeile^.ZeilenNr <> 0) then {Erkennungszeichen, kein leerer Eintrag}
      begin
        ZugProg[Loop] := PZeile;
        ZugProg[Loop]^.Next := NIL;
        PP := ZugProg[Loop];
        while not Eof(Datei) and (PZeile^.ZeilenNr <> 0) do
        begin
          PZeile := NIL;
          New(PZeile);
          read(Datei,PZeile^);
          PZeile^.Next := NIL;
          if (PZeile^.ZeilenNr <> 0) then
          begin
            PP^.Next := PZeile;
            PP := PP^.Next;
          end;
        end;
      end;
    end;
    Close(Datei);
  end;
  Dispose(PZeile);
end;

Procedure SchreibeLokProgDatei;
Var Datei : File of LokProgramm;
    Loop : 0..MaxProgs;
    NILProg : LokProgramm;
    Zeile : PLokProgramm;
begin
  NILProg.ZeilenNr := 0; {<-- das ist das Erkennungszeichen!}
  NILProg.Befehl := Nichts;
  NILProg.Parameter := 0;
  NILProg.Parameter2 := 0;
  NILProg.Next := NIL;
  Assign(Datei,ProgDateiName+'NEU');
  {$I-} Rewrite(Datei) {$I+};
  if IOResult <> 0 then Message('Fehler beim Neuanlegen einer Datei.')
  else
  begin
    for Loop := 1 to MaxProgs do
    begin
      Zeile := ZugProg[Loop];
      while (Zeile <> NIL) and (IOResult = 0) do
      begin
        {$I-} write(Datei,Zeile^) {$I+};
        Zeile := Zeile^.Next;
      end;
      if (IOResult = 0) then {$I-} write(Datei,NILProg) {$I+} {Ende des Progs}
    end;
    {$I-} Close(Datei) {$I+};
    if IOResult <> 0 then Message('Fehler beim Schreiben einer Datei.')
    else ErsetzeDateiVersionen(ProgDateiName,ProgDateiName+'NEU');
  end;
end;


Procedure LeseGBSDatei;
Var Datei : File of GBSElement;
    Loop : Integer;
begin
  Assign(Datei,GBSDateiName);
  {$I-} Reset(Datei) {$I+};
  if IOResult <> 0 then Message('Datei '+GBSDateiName+' nicht gefunden.')
  else
  begin
    Loop := MinGBS;
    while (not Eof(Datei)) and (Loop <= MaxGBS) do
    begin
      read(Datei,GBS[Loop]);
      GBS[Loop].ProgrammPosition := 0; {alle Programme AUS}
      Inc(Loop);
    end;
    Close(Datei);
  end;
end;

Procedure SchreibeGBSDatei;
Var Datei : File of GBSElement;
    Loop : Integer;
begin
  Assign(Datei,GBSDateiName+'NEU');
  {$I-} Rewrite(Datei) {$I+};
  if IOResult <> 0 then Message('Fehler beim Neuanlegen einer Datei.')
  else
  begin
    for Loop := MinGBS to MaxGBS do
    if IOResult = 0 then
      {$I-} write(Datei,GBS[Loop]) {$I+};
    {$I-} Close(Datei) {$I+};
    if IOResult <> 0 then Message('Fehler beim Schreiben einer Datei.')
    else ErsetzeDateiVersionen(GBSDateiName,GBSDateiName+'NEU');
  end;
end;


Procedure InitZuegeUndGBS;
Var Loop : Integer;
begin
  for Loop := 1 to MaxZuege do Zug[Loop] := NIL;
  for Loop := 1 to MaxProgs do ZugProg[Loop] := NIL;
  for Loop := 1 to MaxKontrolls do Kontrolls[Loop] := 0;
  for Loop := 0 to MaxGBS do InitGBSElement(Loop);
  AktuGBS := MaxGBS DIV 2; {Mitte}
  AktuKontroll := 0;
  NothaltTaste := FALSE;
  AllesStop := FALSE;
  FreigabeTaste := FALSE;
  NothaltSteht := FALSE;
end;

Procedure InitMagnet;
Var Loop : 1..MaxMagnet;
begin
  for Loop := 1 to MaxMagnet do
  begin
    New(Magnet[Loop]);
    Magnet[Loop]^.Nummer := (Loop MOD MagnetAdresseMax); {256 wird als Adresse 0 gesendet}
    Magnet[Loop]^.Stellung := Rot;
    Magnet[Loop]^.ZielStellung := Belassen; {nichts ndern}
    Magnet[Loop]^.SchaltDauer := GetMagnetDelay;
  end;
end;


{Layout der LokKontrolls:}
{LokName  Zeile1} {Funktionsname  } {Digitalkran Nr } {Spur1name      }
{[Doppel] 00:00 } {[Doppel]       } {<DREHE><AUF/AB>} {<1> <2> <3> <4>}
{<FAHRT><TELEX >} {               } {<FAHRT><LICHT*>} {<FAHRT><LICHT >}
{       < PROG >} {    on         } {       < PROG >} { 00:00 < PROG >}
{ ** ** < HALT >} { ** ** ** **   } { ** ** < HALT >} { ** ** < HALT >}
{ ** ** <BREMSE>} { ** ** ** **   } { ** ** <BREMSE>} { ** ** <BREMSE>}
{ ** ** <<-Um->>} { ** ** ** **   } { ** ** <<-Um->>} { ** ** <<-Um->>}

Procedure Button(x0, y0 : Word; Papier, Stift : Byte; Ch : Char; Aktiv : Boolean);
Var x,y : Word;
begin
  case Ch of   {Position innerhalb LokKontrolls}
    '1'     : begin x := x0; y := y0  + 1; end;
    '2'     : begin x := x0 + 4; y := y0 + 1; end;
    '3'     : begin x := x0 + 8; y := y0 + 1; end;
    '4'     : begin x := x0 + 12; y := y0 + 1; end;
    'D'     : begin x := x0; y := y0 + 1; end; {Drehen bei Kran}
    'A'     : begin x := x0 + 7; y := y0 + 1; end; {Auf/Ab bei Kran}
    'T','L','#' : begin x := x0 + 7; y := y0 + 2; end; {Telex, Licht}
    'F'     : begin x := x0; y := y0 + 2; end; {Fahrt}
    'P'     : begin x := x0 + 7; y := y0 + 3; end; {Programm bei Lok}
    'p'     : begin x := x0 + 7; y := y0 + 2; end; {Programm bei Funktionsmodell}
    'H'     : begin x := x0 + 7; y := y0 + 4; end; {Halt}
    'B'     : begin x := x0 + 7; y := y0 + 5; end; {Bremse}
    'U'     : begin x := x0 + 7; y := y0 + 6; end; {Umschalten}
  end;
  Farben(Stift,Papier);
  if (Ch = '#') then WriteXY(x,y,'        ')
  else
  begin
    WriteXY(x,y,PfeilNachLinks); {nun Farben tauschen}
    if (Ch in ['1'..'4','D','A','L']) and Aktiv then Farben(White,Stift)
    else if Aktiv then Farben(Black + Blink,Stift)
    else Farben(Black,Stift);
    case Ch of
      '1'..'4' : write(Ch);
      'D' : write('Drehe');
      'A' : write('Auf/Ab');
      'F' : write('Fahrt');
      'T' : write('Telex ');
      'L' : if Aktiv then write('Licht*') else write('Licht ');
      'P','p' : write(' Prog ');
      'H' : write(' Halt ');
      'B' : write('Bremse');
      'U' : write('<-Um->');
    end;
    if (WindMaxY <> WhereY) or (WindMaxX <> WhereX) then
    begin {Farben zurcksetzen, aber nicht in die unterste rechte Ecke !}
      Farben(Stift,Papier);
      write(PfeilNachRechts);
    end;
  end;
end;

Procedure LokKontroll(Position, ZugNr : Byte; AktivesFenster : Boolean);
Const Breite = 15;
      Hoehe = 7;
      PapierInaktiv = Cyan;
      PapierAktiv = Blue;
      Stift = 7;
Var x0, y0 : Word;
    i : 1..4;
    Papier : Byte;
begin
  x0 := 1+ Succ((Pred(Position) MOD 5) * Succ(Breite));
  y0 := ((Pred(Position) DIV 5) * Succ(Hoehe)) + 3;
  if AktivesFenster then Papier := PapierAktiv else Papier := PapierInaktiv;

  Farben(Stift,Papier);
  if AktivesFenster then MakeFenster(Pred(x0),Pred(y0),x0+Breite,y0+Hoehe,2)
  else MakeFenster(Pred(x0),Pred(y0),x0 + Breite,y0 + Hoehe,1);

  Farben(White,-1);
  WriteXY(x0,Pred(y0),'<F');
  write(Position,'>');

  Farben(Stift,-1);
  if Zug[ZugNr] <> NIL then with Zug[ZugNr]^ do
  begin
    case Gattung of
    DigitalLok..DigitalKran :
    begin
      GotoXY(x0 + 1,y0 + 4);
      Farben(Stift * 2,-1);
      WriteBiLine2x3(BToC(Geschwindigkeit DIV 10));
      WriteBiLine2x3(BToC(Geschwindigkeit MOD 10));

      case LokFunktion of
        Ohne : Button(x0,y0,Papier,Stift,'#',FALSE);
        Telex: Button(x0,y0,Papier,Stift,'T',LokFunktionAn);
        Licht: Button(x0,y0,Papier,Stift,'L',LokFunktionAn);
      end;

      Button(x0,y0,Papier,Stift,'F',
             (ZielGeschwindigkeit < Vturn)and(Geschwindigkeit < ZielGeschwindigkeit));
      Button(x0,y0,Papier,Stift,'B',(Geschwindigkeit > ZielGeschwindigkeit));
      Button(x0,y0,Papier,Stift,'U',(ZielGeschwindigkeit = Vturn));
      Button(x0,y0,Papier,Stift,'H',FALSE);
      if (ZugProg[ZugNr] <> NIL) then
        Button(x0,y0,Papier,Stift,'P',(ProgrammPosition > 0));

      if (Gattung = DigitalKran) then
      begin
        Button(x0,y0,Papier,Stift,'D',ModellFunc[1] = KranDrehen);
        Button(x0,y0,Papier,Stift,'A',ModellFunc[2] = LastAufAb);
      end
      else
      begin
        if (Gattung = Spur1DigitalLok) then
        begin
          for i := Fmin to Fmax do
            Button(x0,y0,Papier,Stift,BToC(i),ModellFunc[i]);
          GotoXY(x0 + 1,y0 + 3);
        end
        else GotoXY(x0 + 8,y0 + 1);
        Farben(Stift - 1,-1);
        write(WToS(Stunden,2),':',WToS(Minuten,2));
      end;
    end;
    FunktionsModell :
    begin
      GotoXY(x0 + 1,y0 + 3);
      Farben(Stift * 2,-1);
      for i := Fmin to Fmax do if ModellFunc[i] then write('an ') else write('   ');
      Farben(Stift,-1);
      for i := Fmin to Fmax do
      begin
        GotoXY((Pred(i) * 3)+x0 +1,y0 + 4);
        if ModellFunc[i] then Farben(-1,Papier)
        else Farben(-1,Papier + 2);
        WriteBiLine2x3(BToC(i));
      end;

      if (ZugProg[ZugNr] <> NIL) then
        Button(x0,y0,Papier,Stift,'p',(ProgrammPosition > 0));
    end;
    else
    begin
      WriteXY(x0,y0+3,'konventionell');
    end;
    end;

    Farben(Stift,Papier);
    if Length(Name) > Breite then WriteXY(x0,y0,Copy(Name,1,Breite))
    else WriteXY(x0,y0,Name);
    if (Next <> NIL) and not (Gattung in [DigitalKran, Spur1DigitalLok]) then
    begin
      if (Length(Next^.Name) > (Breite - 7))
      then WriteXY(x0,Succ(y0),Copy(Next^.Name,1,(Breite - 7)))
      else WriteXY(x0,Succ(y0),Next^.Name);
    end;
  end;
end;


Procedure GBSKontroll(Nr : Word; AktivesFenster : Boolean);
Const PapierInaktiv = White;
      PapierAktiv = Blue;
      Stift = Black;
      StartX = 2;
      { StartY = 27; }
Var StartY : Byte;
    Papier : Byte;
    x,y,i,j : Byte;
begin
  if AktivesFenster then Papier := PapierAktiv else Papier := PapierInaktiv;
  Farben(Stift,Papier);
  if NurGBS then StartY := 2 else StartY := 27;
  {Nr gezhlt von 0 bis 428}
  x := Nr MOD Succ(MaxGBSX);
  y := Nr DIV Succ(MaxGBSX);
  if (y > MaxGBSY) or (((Succ(MaxGBSY) * 2) + StartY + 1) > WindMaxY) then
    {EGA => nur 43 Zeilen}
  else with GBS[Nr] do
  begin
    case Status of
      Rot, Gruen, Zusatz : for i := 0 to 3 do
      begin
        Farben(Zustaende[Status].Farbe[Succ(i)],-1);
        WriteXY(StartX + (x * 2) + (i MOD 2), StartY + (y * 2) + (i DIV 2),
                Zustaende[Status].Darstellung[Succ(i)]);
      end;
      else begin {Rot enthlt das Symbol fr Felder ohne Alternative}
        for i := 0 to 3 do
        begin
          Farben(Zustaende[Rot].Farbe[Succ(i)],-1);
          WriteXY(StartX + (x * 2) + (i MOD 2), StartY + (y * 2) + (i DIV 2),
                  Zustaende[Rot].Darstellung[Succ(i)]);
        end;
      end;
    end;
  end;
end;

Procedure GBSAktion(Nr : Word; NeuerStatus : MagnetStellungen);
begin  {Nr gezhlt von 0 bis 428}
  with GBS[Nr] do
  begin
    if (Art <> KeinSchalter) then
    begin
      if (Status = NeuerStatus) then {gleiche Taste wiederholt gedrckt}
      begin
        if (ProgrammPosition > 0) then {laufendes Weichenprogramm}
          ProgrammPosition := -1 * ProgrammPosition {Weichenprogr. anhalten}
        else if (ProgrammPosition < 0) then {angehaltenes Weichenprogr. fortsetzen}
      end
      else ProgrammPosition := 0; {evtl. laufendes Progr. ganz stoppen}
      Status := NeuerStatus;
      if (ProgrammPosition = 0) then ProgrammPosition := 1; {Programm starten}
      GBSKontroll(Nr, (Nr = AktuGBS));
    end;
  end;
end;

Procedure GBSMagnetReferenz(MagnetArtikelNr : Byte; NeueStellung : MagnetStellungen);
Var Loop : Word;
begin
  for Loop := MaxGBS downto MinGBS do
  with GBS[Loop] do
  begin
    if MagnetArtikelNr = MagnetReferenz then
    begin
      Status := NeueStellung;
      if MitGBS then
        GBSKontroll(Loop,(Loop = AktuGBS));
    end;
  end;
end;


Procedure ProcessBildschirm(SpeziellKontroll, SpeziellGBS : Integer);
Var Loop : Word;
begin
  if not NurGBS then
    for Loop := 1 to MaxKontrolls do if Kontrolls[Loop] <> 0 then
    begin
      if (SpeziellKontroll = 0) or (Kontrolls[Loop] = SpeziellKontroll) then
        LokKontroll(Loop,Kontrolls[Loop],(Loop = AktuKontroll));
    end;
  if MitGBS and (SpeziellGBS >= 0) then
  begin
    for Loop := 0 to MaxGBS do
    begin
      if (SpeziellGBS = 0) or (Loop = SpeziellGBS) then
        GBSKontroll(Loop,(Loop = AktuGBS));
    end;
  end;
end;


Procedure ProcessTastatur;
Var Ch : Char;
    FunktionsTaste : Byte;
    P : PFahrzeug;
begin
  if TastaturAktiviert then
  begin
    if ReadUpCaseKey(Ch) then {Funktionstaste oder Special Key}
    begin
      if MitGBS and (Ch in [UpKey,DownKey,LeftKey,RightKey]) then
        GBSKontroll(AktuGBS,FALSE);
      case Ch of
        ShiftTabKey : if not NurGBS then
        begin {SHIFT-TAB}
               if (AktuKontroll > 0) then
                 LokKontroll(AktuKontroll,Kontrolls[AktuKontroll],FALSE);
               FunktionsTaste := Pred(AktuKontroll);
               if (FunktionsTaste < 1)
               or (Kontrolls[FunktionsTaste] = 0) then AktuKontroll := 1
               else AktuKontroll := FunktionsTaste;
               if (Kontrolls[AktuKontroll] = 0) then AktuKontroll := 0
               else LokKontroll(AktuKontroll,Kontrolls[AktuKontroll],TRUE);
        end;
        UpKey :   if (AktuGBS <= MaxGBSX)
                  then AktuGBS := MaxGBS - MaxGBSX + AktuGBS
                  else AktuGBS := AktuGBS - Succ(MaxGBSX);
        DownKey : if (AktuGBS > (MaxGBS - MaxGBSX))
                  then AktuGBS := AktuGBS + MaxGBSX - MaxGBS
                  else AktuGBS := AktuGBS + Succ(MaxGBSX);
        LeftKey : if ((AktuGBS MOD Succ(MaxGBSX)) = 0)
                  then AktuGBS := AktuGBS + MaxGBSX
                  else AktuGBS := Pred(AktuGBS);
        RightKey: if ((AktuGBS MOD Succ(MaxGBSX)) = MaxGBSX)
                  then AktuGBS := AktuGBS - MaxGBSX
                  else AktuGBS := Succ(AktuGBS);
        DeleteKey: if MitGBS then {aktuelles GBS-Element lschen}
                     InitGBSElement(AktuGBS);
        else FunktionsTaste := FuncKey(Ch);
      end;
      if MitGBS and (Ch in [UpKey,DownKey,LeftKey,RightKey,DeleteKey]) then
        GBSKontroll(AktuGBS,TRUE)
      else if not NurGBS then
      begin
        if (AktuKontroll > 0) then
          LokKontroll(AktuKontroll,Kontrolls[AktuKontroll],FALSE);
        if (FunktionsTaste in [1..MaxKontrolls]) then
        begin
          if Kontrolls[FunktionsTaste] = 0 then AktuKontroll := 0
          else AktuKontroll := FunktionsTaste;
        end;
        if (AktuKontroll > 0) then
          LokKontroll(AktuKontroll,Kontrolls[AktuKontroll],TRUE);
      end
    end
    else {"normale" Taste}
    begin
      case Ch of
        TabKey : if not NurGBS then
              begin {TAB}
                if (AktuKontroll > 0) then
                  LokKontroll(AktuKontroll,Kontrolls[AktuKontroll],FALSE);
                FunktionsTaste := Succ(AktuKontroll);
                if (FunktionsTaste > MaxKontrolls)
                or (Kontrolls[FunktionsTaste] = 0) then AktuKontroll := 1
                else AktuKontroll := FunktionsTaste;
                if (Kontrolls[FunktionsTaste] = 0) then AktuKontroll := 0
                else LokKontroll(AktuKontroll,Kontrolls[AktuKontroll],TRUE);
              end;
        'Q' : ProgrammEnde := TRUE;
        'N' : if NothaltSteht then FreigabeTaste := TRUE
              else NothaltTaste := TRUE;
        'S' : AllesStop := TRUE;
        'M' : begin {Menu}
                ProgrammEnde := BefehlsMenu;
                ProcessBildschirm(0,0);
              end;
        'I' : begin {Infos speichern}
                AenderungenSpeichern := not AenderungenSpeichern;
                MenuLeiste;
              end;
        'W' : begin {GBS anzeigen an/aus}
                if MitGBS then SetzeAltenVideoMode
                else UmschaltenFont8x8;
                MitGBS := not MitGBS;
                if (WindMaxY <= 25) and MitGBS then NurGBS := TRUE
                else NurGBS := FALSE;
                LoescheDesktop;
                if MitGBS then
                begin
                  Farben(Black,White);
                  if NurGBS then MakeFenster(1,1,WindMaxX,WindMaxY,2)
                  else MakeFenster(1,26,WindMaxX,WindMaxY,2);
                  WriteXY(2,WindMaxY,'[R]ot [G]rn [Z]usatz'
                          + '  [-] [/] [\] Symbole einfgen'
                          + '  [DEL] Symbol lschen');
                end;
                MenuLeiste;
                ProcessBildschirm(0,0);
              end;
        'G' : if MitGBS then GBSAktion(AktuGBS,Gruen);
        'R' : if MitGBS then GBSAktion(AktuGBS,Rot);
        'Z' : if MitGBS and (GBS[AktuGBS].Art = DreifachSchalter) then
                GBSAktion(AktuGBS,Zusatz);
        '-','/','\' : if MitGBS then {spezielle Elemente ohne Schaltfunktion}
              begin
                InitSpeziellesGBSElement(AktuGBS, Ch);
                GBSKontroll(AktuGBS,TRUE);
              end;
        else
        begin
          if (AktuKontroll in [1..MaxKontrolls])
          and (Zug[Kontrolls[AktuKontroll]] <> NIL) then
          with Zug[Kontrolls[AktuKontroll]]^ do
          begin
            case Ch of
            'P' : if (ZugProg[Kontrolls[AktuKontroll]] <> NIL) then
                  begin
                    if (ProgrammPosition = 0) then ProgrammPosition := 1
                    else ProgrammPosition := (-1) * ProgrammPosition;
                  end;
            'A' : if Gattung = DigitalKran then
                  begin
                    ModellFunc[1] := not KranDrehen;
                    ModellFunc[2] := LastAufAb;
                    ModellFuncAendern := TRUE;
                  end;
            'D' : if Gattung = DigitalKran then
                  begin
                    ModellFunc[1] := KranDrehen;
                    ModellFunc[2] := not LastAufAb;
                    ModellFuncAendern := TRUE;
                  end;
            'F','B','H','U','<','>','L','T' :
            if (Gattung in [DigitalLok..DigitalKran]) then
            begin
              case Ch of
                'F' : if (ZielGeschwindigkeit < Vmax) then Inc(ZielGeschwindigkeit);
                'B' : if (ZielGeschwindigkeit > Vstop) then Dec(ZielGeschwindigkeit);
                'H' : ZielGeschwindigkeit := Vstop;
                'U','<','>' : ZielGeschwindigkeit := Vturn;
                'L','T' : FunktionAendern := TRUE;
              end;
            end;
            '0'..'9' : begin
              if (Ch in ['1'..'4'])
              and (Gattung in [FunktionsModell, Spur1DigitalLok]) then
              begin
                ModellFuncAendern := TRUE;
                ModellFunc[CToB(Ch)] := not ModellFunc[CToB(Ch)];
              end
              else if (Gattung in [DigitalLok..DigitalKran])
              then ZielGeschwindigkeit := CToB(Ch);
            end;
            end; {case}
            {achten auf Mehrfachtraktions-Verknfungen}
            if ((Ch in ['F','B','H','U','<','>','L','T','0'..'9'])
              and (Gattung in [DigitalLok..DigitalKran]))
            or ((Ch in ['A','D']) and (Gattung = DigitalKran))
            or ((Ch in ['1'..'4']) and (Gattung = FunktionsModell))
            then begin
              AktionStart := 0;
              P := Next;
              while (P <> NIL) do
              begin
                if (P^.Gattung = Gattung)
                or ((P^.Gattung in [DigitalLok, DeltaLok])
                    and (Gattung in [DigitalLok, DeltaLok])) then
                begin
                  P^.ZielGeschwindigkeit := ZielGeschwindigkeit;
                  P^.FunktionAendern := FunktionAendern;
                  P^.AktionStart := AktionStart;
                  P^.ModellFunc[CtoB(Ch)] := ModellFunc[CtoB(Ch)];
                  P^.ModellFuncAendern := ModellFuncAendern;
                end;
                P := P^.Next;
                if (P = Next) then P := NIL; {sonst Endlosschleife}
              end;
            end; {Mehrfachtraktion}
            if not NurGBS then LokKontroll(AktuKontroll,Kontrolls[AktuKontroll],TRUE);
          end; {with}
        end; {else}
      end; {case}
    end; {else}
  end; {if Keypressed}
end;

Procedure ProcessAufgaben;
Var Loop, i, g : 0..MaxProgs;
    M : MagnetStellungen;
    PProg, PProgLoop : PLokProgramm;
    P : PFahrzeug;
    Vergangen : Word; {Sekunden}
    PProgrammPosition : ^Integer;
    Arbeiten : Boolean;
begin
  {OldSec enthlt die neue Zeit,
   ProgSec enthlt die Zeit vom letzten Abarbeiten dieses Upros}
  if (ProgSec <= OldSec) then Vergangen := (OldSec - ProgSec)
  else Vergangen := ((OldSec + 60) - ProgSec);

  for Loop := 1 to MaxProgs do
  begin
    if (Loop > MaxZuege) then
    begin
      g := (Loop - MaxZuege - 1) DIV 3; {GBS-Element-Nr}
      case (Loop - MaxZuege - 1) MOD 3 of
        0 : M := Rot;
        1 : M := Gruen;
        2 : M := Zusatz;
      end;
      PProgrammPosition := Addr(GBS[g].ProgrammPosition);
    end
    else PProgrammPosition := Addr(Zug[Loop]^.ProgrammPosition);
    Arbeiten := (Loop <= MaxZuege);
    if Arbeiten then Arbeiten := (Zug[Loop] <> NIL)
    else
      Arbeiten := (GBS[g].Art <> KeinSchalter) and (GBS[g].Status = M);
    if Arbeiten and (PProgrammPosition^ > 0) and (ZugProg[Loop] <> NIL) then
    begin
      i := 1;
      PProg := ZugProg[Loop];
      while (PProgrammPosition^ > i) and (PProg <> NIL) do
      begin
        Inc(i);
        PProg := PProg^.Next;
      end;
      if (PProg = NIL) then
      begin
        PProgrammPosition^ := 0; {Ende}
        ProcessBildschirm(Loop,-1);
      end
      else with PProg^ do
      begin
        case Befehl of {universelle Befehle}
          Zeitverzoegerung :
          begin
            if (Parameter = 0) then Inc(PProgrammPosition^)
            else
            begin
              if (Parameter2 = 0) then {am Anfang des Wartens}
                Parameter2 := Parameter + 1
              else if (Parameter2 = 1) then {am Ende des Wartens}
              begin
                Parameter2 := 0;
                Inc(PProgrammPosition^);
              end
              else {mittendrin im Warten}
              begin
                Parameter2 := Parameter2 - Vergangen;
                if (Parameter2 <= 0) then Parameter2 := 1;
              end;
            end;
          end;
          GotoBefehl :
          begin
            if (Parameter <= 0) then
            begin
              PProgrammPosition^ := 0; {Ende}
              ProcessBildschirm(Loop,-1);
            end
            else PProgrammPosition^ := Parameter;
          end;
          BeepBefehl :
          begin
            Beep;
            Inc(PProgrammPosition^);
          end;
          GBSRot,GBSGruen,GBSZusatz :
          begin
            if (Parameter >= MinGBS) and (Parameter <= MaxGBS) then
            begin
              case Befehl of
                GBSRot : GBSAktion(Parameter,Rot);
                GBSGruen : GBSAktion(Parameter,Gruen);
                GBSZusatz : GBSAktion(Parameter,Zusatz);
              end;
            end;
            Inc(PProgrammPosition^);
          end;
          MagRot, MagGruen :
          begin
            if (Parameter >= MagnetAdresseMin)
            and (Parameter <= MagnetAdresseMax) then
            begin
              if (Magnet[Parameter] <> NIL) then with Magnet[Parameter]^ do
              begin
                case Befehl of
                  MagRot : ZielStellung := Rot;
                  MagGruen : ZielStellung := Gruen;
                end;
              end;
            end;
            Inc(PProgrammPosition^);
          end;
          MagSchaltdauer :  {Schaltdauer aller in diesem Programm folgenden}
          begin             {Magnetartikel setzen}
            if (Parameter >= 0) then
            begin
              PProgLoop := PProg^.Next; {die folgende Programmzeile}
              while (PProgLoop <> NIL) do {bis zur letzten Programmzeile}
              begin
                if (PProgLoop^.Befehl in [MagRot, MagGruen]) then
                begin
                  if (PProgLoop^.Parameter >= MagnetAdresseMin)
                  and (PProgLoop^.Parameter <= MagnetAdresseMax) then
                  begin
                    if (Magnet[PProgLoop^.Parameter] <> NIL) then
                      Magnet[PProgLoop^.Parameter]^.SchaltDauer := Parameter;
                  end;
                end;
                PProgLoop := PProgLoop^.Next; {nchste Zeile}
              end;
            end;
            Inc(PProgrammPosition^);
          end;
          RueckmeldungEin, RueckmeldungAus :
          begin
            if (Parameter >= RueckmeldeAdresseMin)
            or (Parameter <= RueckmeldeAdresseMax) then
            begin
              if TestRueckmeldeEingang(Parameter) then
              begin
                if (Befehl = RueckmeldungEin) then Inc(PProgrammPosition^)
              end
              else
              begin
                if (Befehl = RueckmeldungAus) then Inc(PProgrammPosition^)
              end
            end
            else Inc(PProgrammPosition^);
          end;
          Anhalten,Fahrtstufe,Richtungswechsel,AnFunktion,AusFunktion,
          DrehFunktion,AufAbFunktion :
          if (Loop <= MaxZuege) then with Zug[Loop]^ do
          begin {spezielle Befehle}
            case Befehl of
              DrehFunktion : if (Gattung = DigitalKran) then
              begin
                ModellFunc[1] := KranDrehen;
                ModellFunc[2] := not LastAufAb;
                ModellFuncAendern := TRUE;
              end;
              AufAbFunktion : if (Gattung = DigitalKran) then
              begin
                ModellFunc[1] := not KranDrehen;
                ModellFunc[2] := LastAufAb;
                ModellFuncAendern := TRUE;
              end;
              AnFunktion, AusFunktion :
              begin
                case Gattung of
                  DigitalLok..DigitalKran :
                  begin
                    case Befehl of
                      AnFunktion : FunktionAendern := not LokFunktionAn;
                      AusFunktion : FunktionAendern := LokFunktionAn;
                    end
                  end;
                  FunktionsModell : if (Parameter in [Fmin..Fmax]) then
                  begin
                    ModellFuncAendern := TRUE;
                    case Befehl of
                      AnFunktion : ModellFunc[Parameter] := TRUE;
                      AusFunktion : ModellFunc[Parameter] := FALSE;
                    end;
                  end;
                end;
              end;
              else if (Gattung in [DigitalLok..DigitalKran]) then
              begin
                case Befehl of
                  Anhalten : ZielGeschwindigkeit := Vstop;
                  Fahrtstufe : ZielGeschwindigkeit := Parameter;
                  Richtungswechsel : ZielGeschwindigkeit := Vturn;
                  else {jeder andere Befehl} {nichts};
                end;
              end;
            end; {case Befehl}
            {achten auf Mehrfachtraktions-Verknfungen}
            if ((Befehl in [Anhalten,Fahrtstufe,Richtungswechsel,
                           AnFunktion,AusFunktion])
                and (Gattung in [DigitalLok..DigitalKran]))
            or ((Befehl in [DrehFunktion,AufAbFunktion])
                and (Gattung = DigitalKran))
            or ((Befehl in [AnFunktion,AusFunktion])
                and (Gattung = FunktionsModell)
                and (Parameter in [Fmin..Fmax]))
            then begin
              AktionStart := 0;
              P := Zug[Loop]^.Next;
              while (P <> NIL) do
              begin
                if (P^.Gattung = Gattung)
                or ((P^.Gattung in [DigitalLok, DeltaLok])
                    and (Gattung in [DigitalLok, DeltaLok])) then
                begin
                  P^.ZielGeschwindigkeit := ZielGeschwindigkeit;
                  P^.FunktionAendern := FunktionAendern;
                  P^.AktionStart := AktionStart;
                  P^.ModellFunc[Parameter] := ModellFunc[Parameter];
                  P^.ModellFuncAendern := ModellFuncAendern;
                end;
                P := P^.Next;
                if (P = Next) then P := NIL; {sonst Endlosschleife}
              end;
            end;
            Inc(PProgrammPosition^);
          end;
          else {jeder andere Befehl} Inc(PProgrammPosition^);
        end; {case}
      end;
    end;
  end;
  ProgSec := OldSec;
end;

Procedure ProcessUhr;
Var Sec, Vergangen : Word; {Sekunden}
    Loop : 1..MaxZuege;
begin
  {OldSec enthlt die Zeit vom letzten Durchlauf durch dieses Upro,
   Sec nimmt jetzt die aktuelle neue Zeit auf}
  Sec := SekundenZeiger; {Minuten werden nicht nachgehalten}
  if (OldSec <= Sec) then Vergangen := (Sec - OldSec)
  else Vergangen := ((Sec + 60) - OldSec);
  if (Vergangen <> 0) then
  begin
    for Loop := 1 to MaxZuege do if Zug[Loop] <> NIL then
    with Zug[Loop]^ do if (Gattung in [DigitalLok..DigitalKran]) then
    begin
      if (AktionStart >= 0) then
        AktionStart := AktionStart + Vergangen;
      if (Geschwindigkeit > Vstop) then
      begin
        Sekunden := Sekunden + Vergangen;
        if (Sekunden > 59) then
        begin
          Inc(Minuten);
          Sekunden := Sekunden MOD 60;
          if (Minuten > 59) then
          begin
            Inc(Stunden);
            Minuten := Minuten MOD 60;
          end;
          ProcessBildschirm(Loop,-1);
        end;
      end;
    end;
  end;
  OldSec := Sec;
end;

Procedure ProcessSchnittstelle;
Var Loop : 1..MaxInt;
    MagnetEin : Boolean;
    OldMagnetDelay, MagnetSchaltDauer : Word;
begin
  if NothaltTaste and not NothaltSteht then
  begin        {bei Nothalt werden alle Motoren angehalten, aber die}
    Nothalt;   {Control Unit m6021 merkt sich die alten Geschwindigkeiten}
    NothaltSteht := TRUE;    {und stellt sie bei Freigabe wieder her!}
    NothaltTaste := FALSE;
    MenuLeiste;
    for Loop := 1 to MaxZuege do if Zug[Loop] <> NIL then
    with Zug[Loop]^ do
    begin
      if (Gattung in [DigitalLok..DigitalKran]) then
      begin
        {die alte ZielGeschwindigkeit wird nicht verndert, soda nach}
        {Nothaltfreigabe dieses Programm die alten Geschwindigkeiten wieder-}
        {herstellt unabhngig von der Control Unit}
        Geschwindigkeit := Vstop;
        AktionStart := 0;
      end;
      ProgrammPosition := (-1) * Abs(ProgrammPosition); {Programmunterbrechung}
    end;
    ProcessBildschirm(0,0);
  end
  else if FreigabeTaste then
  begin
    Freigabe;
    NothaltSteht := FALSE;
    FreigabeTaste := FALSE;
    MenuLeiste;
  end
  else if not NothaltSteht then
  begin
    for Loop := 1 to MaxZuege do if Zug[Loop] <> NIL then
    with Zug[Loop]^ do
    begin
      case Gattung of
        DigitalLok..DigitalKran : begin
          if AllesStop then
          begin
            if FunktionAendern then
            begin
              LokFunktionAn := not LokFunktionAn;
              FunktionAendern := (LokFunktion = Telex) and LokFunktionAn;
            end;
            ProgrammPosition := (-1) * Abs(ProgrammPosition); {Programmunterbrechung}
            ZielGeschwindigkeit := Vstop;
            if (Geschwindigkeit <> Vstop) then {wenn sie nicht schon steht...}
            begin {...dann anhalten}
              {LokUmschalten beinhaltet einen LokHalt !}
              {Uhlenbrock-Decoder DAL 770 vertrgt kein zweimaliges Umschalten kurz hintereinander}
              LokUmschalten(Nummer,LokFunktionAn); {damit auch die 5*Digital-}
              Geschwindigkeit := Vstop;            {Decoder-Loks sofort stehen}
              ProcessBildschirm(Loop,-1);          {Loks sind nun umgeschaltet !}
              if PortError then Message(TimeOutMessage);
            end;
            AktionStart := -1;
          end {AllesStop}
          else
          begin
            if ((ZielGeschwindigkeit > Geschwindigkeit)
               and (AktionStart >= StartVerzoegerung))
               or ((ZielGeschwindigkeit < Geschwindigkeit)
               and (AktionStart >= BremsVerzoegerung)) then
            begin
              if FunktionAendern then
              begin
                LokFunktionAn := not LokFunktionAn;
                FunktionAendern := (LokFunktion = Telex) and LokFunktionAn;
              end;
              if (ZielGeschwindigkeit = Vturn) then
              begin
                LokUmSchalten(Nummer,LokFunktionAn);
                Richtung := not Richtung;
                ZielGeschwindigkeit := Geschwindigkeit;
                AktionStart := 0;
                Geschwindigkeit := Vstop;
                {da ZielGeschwindigkeit die alten Geschwindigkeit enthlt,}
                {wird die Lok von diesem Programm automatisch wieder beschleunigt}
              end
              else
              begin
                if (Geschwindigkeit > ZielGeschwindigkeit) then Dec(Geschwindigkeit)
                else Inc(Geschwindigkeit);
                if (Geschwindigkeit = ZielGeschwindigkeit) then AktionStart := -1
                else AktionStart := 0;
                LokBefehl(Nummer,Geschwindigkeit,LokFunktionAn);
              end;
              ProcessBildschirm(Loop,-1);
              if PortError then Message(TimeOutMessage);
            end {Geschwindigkeit ndern}
            else if FunktionAendern then
            begin
              LokFunktionAn := not LokFunktionAn;
              FunktionAendern := (LokFunktion = Telex) and LokFunktionAn;
              LokBefehl(Nummer,Geschwindigkeit,LokFunktionAn);
              ProcessBildschirm(Loop,-1);
              if PortError then Message(TimeOutMessage);
            end;
            if (Gattung in [DigitalKran, Spur1DigitalLok])
            and ModellFuncAendern then
            begin
              if (Gattung = DigitalKran)
              and (ModellFunc[1] and ModellFunc[2]) then
              begin
                ModellFunc[1] := not KranDrehen;
                ModellFunc[2] := not LastAufAb;
              end;
              FunktionsBefehl(Nummer,ModellFunc[1],ModellFunc[2],ModellFunc[3],ModellFunc[4]);
              ModellFuncAendern := FALSE;
              ProcessBildschirm(Loop,-1);
              if PortError then Message(TimeOutMessage);
            end;
          end; {not AllesStop}
        end;
        FunktionsModell : begin
          if AllesStop then
          begin
            ProgrammPosition := (-1) * Abs(ProgrammPosition); {Programmunterbrechung}
          end
          else if ModellFuncAendern then
          begin
            FunktionsBefehl(Nummer,ModellFunc[1],ModellFunc[2],ModellFunc[3],ModellFunc[4]);
            ModellFuncAendern := FALSE;
            ProcessBildschirm(Loop,-1);
            if PortError then Message(TimeOutMessage);
          end;
        end;
      end; {case}
    end; {for Loop := 1 to MaxZuege do}
    MagnetEin := FALSE;
    MagnetSchaltDauer := GetMagnetDelay;
    for Loop := 1 to MaxMagnet do if Magnet[Loop] <> NIL then
    with Magnet[Loop]^ do
    begin
      case ZielStellung of
        Belassen : ; {nichts ndern}
        Rot, Gruen : begin
          if MagnetEin then Delay(MagnetSchaltDauer); {vorheriger Magnetartikel}
          if (ZielStellung = Rot) then MagnetRot(Nummer)
          else {ZielStellung = Gruen} MagnetGruen(Nummer);
          MagnetSchaltDauer := SchaltDauer; {dieses Magnetartikels}
          MagnetEin := TRUE;
          {nun Rckmeldung an das GBS}
          Stellung := ZielStellung; {neue Stellung merken}
          GBSMagnetReferenz(Nummer, Stellung);
          if PortError then Message(TimeOutMessage);
        end;
      end;
      ZielStellung := Belassen;
    end; {for Loop := 1 to MaxMagnet do}
    if MagnetEin then
    begin
      OldMagnetDelay := GetMagnetDelay;
      SetMagnetDelay(MagnetSchaltDauer);
      MagnetAus; {sende Byte 32}
      if PortError then Message(TimeOutMessage);
      SetMagnetDelay(OldMagnetDelay);
    end;
  end; {if not NothaltSteht then}
  AllesStop := FALSE;
end;


Procedure ParameterAuswertung;
Var Loop, i : Byte;
    S : String;
begin
  for Loop := 1 to ParamCount do
  begin
    S := ParamStr(Loop);
    if (S[1] in ['-','/','\']) then
    begin
      if (Length(S) = 1) then S := ''
      else S := Copy(S,2,Length(S)-1);
    end;
    for i := 1 to Length(S) do S[i] := UpCase(S[i]);
    if (Length(S) > 3) and (Copy(S,1,3) = 'COM')
    and (S[4] in ['1'..'4']) then InterfaceComPort := CtoB(S[4])
    else
    begin {alle anderen Parameter sind ungltig}
      writeln('Mrklin-Digital Loksteuerung ***************** 1994',
        #13#10'Version ',VersionNr,
        #13#10'(c) Manfred Fischer, Heroldstr. 44, D-48163 Mnster',
        #13#10,
        #13#10'Ein Programm zur Steuerung von Digital- u. Delta-  ',
        #13#10'Loks, -Krnen, Funktionsmodellen, Magnetartikeln u.',
        #13#10'Auswertung von Rckmeldemodulen mit Lok-Controls,  ',
        #13#10'Lok-Fahrplnen, GBS und Weichenfahrstraen, passend',
        #13#10'zum Mrklin-Digital-Interface 6050/6051.           ',
        #13#10,
        #13#10'Parameter:  -? | /? | ?    listet diesen Text      ',
        #13#10'            COM1: | COM2:  Auswahl des PC-Com-Ports',
        #13#10'          | COM3: | COM4:  (ohne Parameter ist COM1',
        #13#10'                           voreingestellt)         ');
      Halt(0);
    end;
  end;
end;

begin
  ParameterAuswertung;
  ProgrammEnde := FALSE;
  AenderungenSpeichern := TRUE; {nderungen auf Disk bei Programmende speichern}
  MitGBS := FALSE; {am Anfang nur LokKontrolls anzeigen}
  NurGBS := FALSE; {dito}
  InitSchnittstelle;
  InitZuegeUndGBS;
  InitMagnet;
  InitBildschirm;
  LeseLokDatei;
  LeseLokProgDatei;
  LeseGBSDatei;
  ProcessBildschirm(0,0);
  InitUhr;
  repeat
    ProcessTastatur;
    ProcessAufgaben;
    ProcessUhr;
    ProcessSchnittstelle;
  until ProgrammEnde;
  if AenderungenSpeichern then
  begin
    SchreibeLokDatei;
    SchreibeLokProgDatei;
    SchreibeGBSDatei;
  end;
  SetzeAltenVideoMode;
end.

