
{Datei: C:\Pascal\Progs6\Digital.Pas ******26.08.1994 **}
{TP 4.0 Unit: Upros zu Mrklin Digital und Mrklin Delta}
{ (c) Manfred Fischer, Heroldstrae 44, D-48163 Mnster }
{Korrektur: 16.Juni 1995 *mf* Rckmeldemodule, Umschalten}
{letzte nderung: 02.05.2004: Magnetartikelschalten ROT = 34}

Unit Digital; {Uses Crt, RS232}

Interface

Const ComPort : Byte = 1; {an diesem ist das Interface angeschlossen, COM1:}
      TimeOutLimit : Word = 5000;
      PortError : Boolean = FALSE; {wenn TimeOut auftrat}
      MagnetDelay : Word = 1000; {Delay in Millisekunden, min 80ms, max 1000ms, ideal 150ms}

      Vstop =  0; {Halt-Geschwindigkeit bei Mrklin-Digital}
      Vmin  =  1; {minimal mgliche Geschwindigkeit bei Mrklin-Digital}
      Vmax  = 14; {maximal mgliche Geschwindigkeit bei Mrklin-Digital}
      Vturn = 15; {"Geschwindigkeit" fr Fahrtrichtungsumschaltung}
      Fmin  =  1; {kleinste mgliche Funktionsnummer bei Funktionsmodellen}
      Fmax  =  4; {grte mgliche Funktionsnummer bei Funktionsmodellen}
      LokAdresseMin =  1; {bei Mrklin-Digital mglicher Lok-Adressen-}
      LokAdresseMax = 80; {Bereich: 1..80}
      FModellAdresseMin =  1; {bei Mrklin-Digital mglicher Funktions-}
      FModellAdresseMax = 80; {modell-Adressen-Bereich: 1..80}
      DeltaKonventionellAdresse = 0; {Delta-Decoder m6603}
      MagnetAdresseMin =   1; {bei Mrklin-Digital mglicher Magnetartikel-}
      MagnetAdresseMax = 256; {Adressen-Bereich: 1..256}
      RueckmeldeAdresseMin =   1; {bei Mrklin-Digital mglicher Rckmelde-}
      RueckmeldeAdresseMax = 496; {modul-Adressen-Bereich: 1..496}


Type String4 = String[4]; {Delta Codier-Schalter m6603}
     String8 = String[8]; {Digital Codier-Schalter}
     TString = String[20]; {textliche Erluterungen}

Function DigitalSchalter2Adresse(S : String8) : Byte;
Function Adresse2DigitalText(Adresse : Byte) : TString;
Function Adresse2DigitalSchalter(Adresse : Byte) : String8;
Function IsDigitalKranAdresse(Adresse : Byte) : Boolean;

Function DeltaSchalter2Adresse(S : String4) : Byte;
Function Adresse2DeltaText(Adresse : Byte) : TString;
Function Adresse2DeltaSchalter(Adresse : Byte) : String4;
Function IsDeltaAdresse(Adresse : Byte) : Boolean;

Procedure SetComPort(Neu : Byte);
Procedure SetMagnetDelay(MilliSekunden : Word);
Function  GetMagnetDelay : Word; {in Millisekunden}
Procedure DigitalInterfaceInit;

Procedure NotHalt;
Procedure Freigabe;

Procedure LokBefehl(LokNr, Geschwindigkeit : Byte; MitFunktion : Boolean);
Procedure LokHalt(LokNr : Byte; MitFunktion : Boolean);
Procedure LokUmschalten(LokNr : Byte; MitFunktion : Boolean);

Procedure FunktionsBefehl(FktNr : Byte; F1, F2, F3, F4 : Boolean);

Procedure MagnetAus;
Procedure MagnetBefehl(ArtikelNr : Byte; Befehl : Byte);
Procedure MagnetGruen(ArtikelNr : Byte);
Procedure MagnetRot(ArtikelNr : Byte);

Procedure RueckmeldemoduleRuecksetzen(Ausschalten : Boolean);
Function  RueckmeldemodulLesen(ModulNr : Byte {1..31}) : Word;
Function  TestRueckmeldemodul(ModulNr : Byte {1..31};
                              Eingang : Byte {1..16}) : Boolean;
Function  TestRueckmeldeEingang(Eingang : Word {31*16 => 1..496}) : Boolean;


Implementation

Uses Crt {fr Delay}, RS232;

{---------------------------------------------------}
{Funktionen bzgl. der Schalterstellungen der Decoder}
{---------------------------------------------------}

Function DigitalSchalter2Adresse(S : String8) : Byte;
Var Erg : Byte;
    Loop : Byte;
begin
  if (S[1] <> '-')and(S[3] <> '-')
  and(S[5] <> '-')and(S[7] <> '-') then Erg := LokAdresseMax
  else
  begin
    Erg := 0;
    for Loop := 4 downto 1 do
    begin
      Erg := Erg * 3;
      if (S[Loop * 2] <> '-') then Erg := Erg + 1
      else if (S[(Loop * 2) - 1] <> '-') then Erg := Erg + 2;
    end;
    Erg := LokAdresseMax - Erg;
  end;
  DigitalSchalter2Adresse := Erg;
end;

Function Adresse2DigitalText(Adresse : Byte) : TString;
begin
  case Adresse of
     8 : Adresse2DigitalText := 'Micheline grn';
    10 : Adresse2DigitalText := 'Kellnerwagen';
    20 : Adresse2DigitalText := 'Tanzwagen';
    59 : Adresse2DigitalText := 'Kf II';
    62 : Adresse2DigitalText := 'Micheline rot';
    76 : Adresse2DigitalText := 'Glaskasten grn';
    77 : Adresse2DigitalText := 'B VI Tristan';
    79 : Adresse2DigitalText := 'LAG Triebwg. ET 194';
    else Adresse2DigitalText := '';
  end;
end;

Function Adresse2DigitalSchalter(Adresse : Byte) : String8;
{Setzt eine Lokadresse um in die Schalterstellungsfolge des Digitaldecoders.}
{Ternre Speicherung der Adresse: Schalterpaare sind niemals}
{gleichzeitig ON; 2 Bits werden zur Darstellung von 3 Zustnden}
{verbraucht; Adresse 80 ist ein Sonderfall.}
Var Erg : String8;
    Loop, A : Byte;
begin
  if (Adresse >= LokAdresseMax) then Erg := '1-3-5-7-'
  else
  begin
    Erg := '';
    A := LokAdresseMax - Adresse;
    for Loop := 1 to 4 do
    begin
      case (A MOD 3) of
        0 : Erg := Erg + '--';
        1 : Erg := Erg + '-x';
        2 : Erg := Erg + 'x-';
      end;
      A := A DIV 3;
    end;
    for Loop := 1 to 8 do
      if (Erg[Loop] = 'x') then Erg[Loop] := Chr(Loop + Ord('0'));
  end;
  Adresse2DigitalSchalter := Erg;
end;

Function IsDigitalKranAdresse(Adresse : Byte) : Boolean;
begin {voreingestellt ist bei den Krnen Adresse 30}
  IsDigitalKranAdresse := (Adresse in [1,3,4,9,10,12,13,27,28,
                                       30,31,36,37,39,40,80]);
end;

Function Adresse2DeltaSchalter(Adresse : Byte) : String4;
{Setzt eine Lokadresse um in die Schalterstellungsfolge des Deltamoduls 6603.}
{Ternre Speicherung der Adresse, beim Delta-Modul fallen gegenber}
{dem Digitaldecoder aber die "geraden" Schalter weg}
{Adresse 0 ist ein Sonderfall: alle Schalter auf "off" -> konv. Wechselstrom}
Var S : String8;
    Loop : Byte;
begin
  if (Adresse = DeltaKonventionellAdresse) then S := '--------'
  else S := Adresse2DigitalSchalter(Adresse);
  S := S[1] + S[3] + S[5] + S[7];
  for Loop := 1 to 4 do
    if (S[Loop] <> '-') then S[Loop] := Chr(Loop + Ord('0'));
  Adresse2DeltaSchalter := Copy(S,1,4);
end;

Function DeltaSchalter2Adresse(S : String4) : Byte;
Var DigitalS : String8;
    Loop : Byte;
begin
  if (S = '----') then DeltaSchalter2Adresse := DeltaKonventionellAdresse
  else
  begin
    DigitalS := '--------';
    for Loop := 1 to 4 do DigitalS[Pred(Loop * 2)] := S[Loop];
   DeltaSchalter2Adresse := DigitalSchalter2Adresse(DigitalS);
  end;
end;

Function Adresse2DeltaText(Adresse : Byte) : TString;
begin
  case Adresse of
     0 : Adresse2DeltaText := 'konv. Wechselstrom';
    24 : Adresse2DeltaText := 'Delta-Elektrolok';
    60 : Adresse2DeltaText := 'Delta-Triebwagen';
    72 : Adresse2DeltaText := 'Delta-Diesellok';
    78 : Adresse2DeltaText := 'Delta-Dampflok';
    80 : Adresse2DeltaText := 'Delta-Handregler';
    2,6,8,18,20,26,54,56,62,74 : Adresse2DeltaText := 'Delta-Modul 6603';
    else Adresse2DeltaText := '';
  end;
end;

Function IsDeltaAdresse(Adresse : Byte) : Boolean;
begin
  IsDeltaAdresse := (Adresse in [0,2,6,8,18,20,24,26,54,56,60,62,72,74,78,80]);
end;


{--------------------------------------------}
{Prozeduren zur Steuerung von Mrklin Digital}
{--------------------------------------------}

Procedure SetComPort(Neu : Byte);
begin {berprft auf gltige Werte}
  if (Neu in [1..RS232.ComPorts]) then ComPort := Neu
end;

Procedure SetMagnetDelay(MilliSekunden : Word);
begin
  if (MilliSekunden <= 1000) then
    MagnetDelay := MilliSekunden
end;

Function  GetMagnetDelay : Word; {in Millisekunden}
begin
  GetMagnetDelay := MagnetDelay;
end;

Procedure DigitalInterfaceInit;
Var TimeOut : Word;
begin
  RS232.InitCom(ComPort, {globale "Const" dieser Unit, default COM1:}
                  2400,    {Baud}
                  8,       {Datenbits}
                  'N',     {= no Parity}
                  2);      {Stopbits}
  TimeOut := 0;
  repeat Inc(TimeOut) until RS232.ComReady(ComPort)
                         or (TimeOut > TimeOutLimit);
  RS232.SendChar(ComPort,#32); {alle Magnetartikel ausschalten}
  PortError := (TimeOut > TimeOutLimit);
end;

Procedure NotHalt;
begin
  RS232.SendChar(ComPort,#97);
  {nun liegt am Port stndig "not CTS"}
end;

Procedure Freigabe;
begin
  {egal, ob Port CTS ist oder nicht}
  RS232.SendChar(ComPort,#96);
end;

Procedure LokBefehl(LokNr, Geschwindigkeit : Byte; MitFunktion : Boolean);
Var TimeOut : Word;
begin
  TimeOut := 0;
  if (LokNr in [LokAdresseMin..LokAdresseMax]) then
  begin
    repeat Inc(TimeOut) until RS232.ComReady(ComPort)
                           or (TimeOut > TimeOutLimit);
    PortError := (TimeOut > TimeOutLimit);
    if not PortError then
    begin
      if MitFunktion then
        RS232.SendChar(ComPort,Chr((Geschwindigkeit AND Vturn)+ 16))
      else RS232.SendChar(ComPort,Chr(Geschwindigkeit AND Vturn));
      TimeOut := 0;
      repeat Inc(TimeOut) until RS232.ComReady(ComPort)
                             or (TimeOut > TimeOutLimit);
      PortError := (TimeOut > TimeOutLimit);
      {nun aber in jedem Fall}
      RS232.SendChar(ComPort,Chr(LokNr));
    end;
  end;
end;

Procedure LokHalt(LokNr : Byte; MitFunktion : Boolean);
begin
  LokBefehl(LokNr,Vstop,MitFunktion);
end;

Procedure LokUmschalten(LokNr : Byte; MitFunktion : Boolean);
begin
  LokHalt(LokNr,MitFunktion);
  Delay(150); {damit die Loks den Umschaltbefehl auch akzeptieren}
  LokBefehl(LokNr,Vturn,MitFunktion);
  LokHalt(LokNr,MitFunktion); {damit Uhlenbrock-Decoder nicht in den Programmiermodus geraten}
end;

Procedure FunktionsBefehl(FktNr : Byte; F1, F2, F3, F4 : Boolean);
Var TimeOut : Word;
    B : Byte;
begin
  TimeOut := 0;
  if (FktNr in [FModellAdresseMin..FModellAdresseMax]) then
  begin
    repeat Inc(TimeOut) until RS232.ComReady(ComPort)
                           or (TimeOut > TimeOutLimit);
    PortError := (TimeOut > TimeOutLimit);
    if not PortError then
    begin
      {************anschaulich, aber langsam:
      B := 64;
      if F1 then B := B + 1;
      if F2 then B := B + 2;
      if F3 then B := B + 4;
      if F4 then B := B + 8;
      **************************************}
      B := 64 + Ord(F1) + (2*Ord(F2)) + (4*Ord(F3)) + (8*Ord(F4)); {schneller}
      RS232.SendChar(ComPort,Chr(B));
      TimeOut := 0;
      repeat Inc(TimeOut) until RS232.ComReady(ComPort)
                             or (TimeOut > TimeOutLimit);
      PortError := (TimeOut > TimeOutLimit);
      {nun aber in jedem Fall}
      RS232.SendChar(ComPort,Chr(FktNr));
    end;
  end;
end;

Procedure MagnetAus;
{mit dem Senden von Byte 32 werden alle Magnetartikel ausgeschaltet}
Var TimeOut : Word;
begin
  Delay(MagnetDelay); {default 1sec, Maerklin recommends 150ms}
  TimeOut := 0;
  repeat Inc(TimeOut) until RS232.ComReady(ComPort)
                         or (TimeOut > TimeOutLimit);
  RS232.SendChar(ComPort,#32); {in jedem Fall versuchen: alle Magnetartikel ausschalten}
  PortError := (TimeOut > TimeOutLimit);
end;

Procedure MagnetBefehl(ArtikelNr : Byte; Befehl : Byte);
Var TimeOut : Word;
begin
  TimeOut := 0;
  repeat Inc(TimeOut) until RS232.ComReady(ComPort)
                         or (TimeOut > TimeOutLimit);
  PortError := (TimeOut > TimeOutLimit);
  if not PortError then
  begin
    RS232.SendChar(ComPort,Chr(Befehl));
    TimeOut := 0;
    repeat Inc(TimeOut) until RS232.ComReady(ComPort)
                           or (TimeOut > TimeOutLimit);
    PortError := (TimeOut > TimeOutLimit);
    {in jedem Fall versuchen: Befehl vervollstndigen}
    RS232.SendChar(ComPort,Chr(ArtikelNr MOD MagnetAdresseMax));
    {Magnetartikel-Nr 256 wird als Adresse 0 gesendet}
  end;
end;

Procedure MagnetGruen(ArtikelNr : Byte);
begin
  MagnetBefehl(ArtikelNr, 33)    (*korr*2004*)
end;

Procedure MagnetRot(ArtikelNr : Byte);
begin
  MagnetBefehl(ArtikelNr, 34)    (*korr*2004*)
end;

Procedure RueckmeldemoduleRuecksetzen(Ausschalten : Boolean);
{Voreingestellt ist, da die Rckmeldemodule nach jedem Auslesen}
{der Werte zurck gesetzt werden; dies lt sich mit dem Senden}
{von Byte 128 ausschalten und mit dem Senden von Byte 192 wieder}
{einschalten.}
Var TimeOut : Word;
begin
  TimeOut := 0;
  repeat Inc(TimeOut) until RS232.ComReady(ComPort)
                         or (TimeOut > TimeOutLimit);
  PortError := (TimeOut > TimeOutLimit);
  if not PortError then
  begin
    if Ausschalten then RS232.SendChar(ComPort,#128)
    else RS232.SendChar(ComPort,#192); {Einschalten, ist Default}
  end;
end;

Function RueckmeldemodulLesen(ModulNr : Byte {1..31}) : Word;
{Ein Rckmeldemodul (sie werden gezhlt von 1 bis 31) hat 16 Eingnge.}
{Das Senden von Byte (192 + ModulNr)}
{liefert den Zustand dieser Eingnge in zwei aufeinanderfolgenden Bytes.}
{Diese Funktion liefert das Ergebnis in einem Word (16-Bit) zurck.}
Var TimeOut : Word;
    InByte1, InByte2 : Char; {da die Schnittstelle nur Bytes liefert}
begin
  TimeOut := 0;
  repeat Inc(TimeOut) until RS232.ComReady(ComPort)
                         or (TimeOut > TimeOutLimit);
  PortError := (TimeOut > TimeOutLimit);
  if PortError then RueckmeldemodulLesen := 0 {Fehler}
  else
  begin
    {noch vorhandenen Datenmll in der Leitung entfernen}
    while RS232.CharThere(ComPort) do InByte1 := RS232.GetChar(ComPort);

    InByte2 := #0;
    TimeOut := 0;
    RS232.SendChar(ComPort, Chr(192 + ModulNr)); {abfragen}
    while RS232.CharThere(ComPort) or (TimeOut < TimeOutLimit) do {lesen}
    begin
      if RS232.CharThere(ComPort) then
      begin
        InByte1 := InByte2;
        InByte2 := RS232.GetChar(ComPort);
        TimeOut := 0;
      end
      else Inc(TimeOut);
    end; {die letzten beiden eingelesenen Bytes stammen vom gesuchten Modul}

    RueckmeldemodulLesen := (Ord(InByte1) * 256) + Ord(InByte2);
  end;
end;

Function TestRueckmeldemodul(ModulNr : Byte {1..31};
                             Eingang : Byte {1..16}) :  Boolean;
Var ModulStatus : Word;
{liefert TRUE, wenn an Modul "ModulNr" der Eingang "Eingang" gesetzt ist}
begin
  ModulStatus := RueckmeldemodulLesen(ModulNr);
  TestRueckmeldemodul := Odd(ModulStatus SHR Pred(Eingang));
end;

Function TestRueckmeldeEingang(Eingang : Word {31*16 => 1..496}) : Boolean;
{die Eingnge kann man auch von 1 bis 496 durchzhlen}
begin
  if (Eingang >= RueckmeldeAdresseMin)
  and(Eingang <= RueckmeldeAdresseMax) then
    TestRueckmeldeEingang := TestRueckmeldemodul(Succ(Pred(Eingang) DIV 16),
                                                 Succ(Pred(Eingang) MOD 16))
  else TestRueckmeldeEingang := FALSE;
end;


end. {no Inits}
