
{Datei: C:\Pascal\Units\RollMenu.Pas }
{TurboPascal 4.0 Unit --------- Menusystem fr TextMode}
{(c) Manfred Fischer, Heroldstrae 44, D-48163 Mnster, den 31.08.1994}
{erweitert um RollMenuInsert + RollMenuDelete, 05.10.1994}

Unit RollMenu;

Interface

Type PRollMenuZeile = ^RollMenuZeile;
     RollMenuInhaltType = String[30];
     RollMenuZeile = Record
       Inhalt : RollMenuInhaltType;
       Next : PRollMenuZeile;
     end;
     RollMenuType = Record
       x0, y0, Breite : Word; {linke obere Ecke}
       Zeilen : PRollMenuZeile; {erster Menueintrag von oben}
       AktuIndex : Word; {Nr des aktuellen/selektierten Menueintrags}
       TopIndex, DownIndex : Word; {welcher Bereich gerade angezeigt wird}
     end;

Procedure RollMenuInit(var Menu : RollMenuType; x,y,hoehe,breite : Word);
Procedure RollMenuAppend(var Menu : RollMenuType; NeuerInhalt : RollMenuInhaltType);
Procedure RollMenuInsert(var Menu : RollMenuType; Index : Word; NeuerInhalt : RollMenuInhaltType);
{eine Menuzeile VOR die mit Index bezeichnete Zeile einfgen}
Procedure RollMenuDelete(var Menu : RollMenuType; Index : Word);
{die mit Index (gezhlt von 1 bis ..) bezeichnete Menuzeile entfernen}
Procedure RollMenuShow(var Menu : RollMenuType);
Function RollMenuAktion(var Menu : RollMenuType; Taste : Word) : Word;



Implementation

Uses Crt;

Const CursorUP = Ord('H');
      CursorDown = Ord('P');
      SelectTaste = 13;
      EscapeTaste = 27;


Function RollMenuIndex(Menu : PRollMenuZeile; Nr : Word) : PRollMenuZeile;
Var Loop : Word;
    Erg : PRollMenuZeile;
begin
  Erg := Menu;
  Loop := 1;
  while (Loop < Nr) and (Erg <> NIL) do
  begin
    Inc(Loop);
    Erg := Erg^.Next;
  end;
  RollMenuIndex := Erg;
end;

Procedure _RollMenuAppend(var StammMenu, NeuerEintrag : PRollMenuZeile);
var P : PRollMenuZeile;
begin
  if (StammMenu = NIL) then StammMenu := NeuerEintrag
  else if (StammMenu^.Next = NIL) then StammMenu^.Next := NeuerEintrag
  else
  begin
    P := StammMenu^.Next;
    while (P^.Next <> NIL) do P := P^.Next;
    P^.Next := NeuerEintrag;
  end;
end;

Procedure _RollMenuInsert(var StammMenu : PRollMenuZeile;
                          NeuePosition : PRollMenuZeile;
                          var NeuerEintrag : PRollMenuZeile);
var P : PRollMenuZeile;
begin
  if (StammMenu = NIL) then StammMenu := NeuerEintrag
  else if (StammMenu = NeuePosition) then
  begin
    NeuerEintrag^.Next := StammMenu;
    StammMenu := NeuerEintrag;
  end
  else if (NeuePosition = NIL)
  or (StammMenu^.Next = NIL) then _RollMenuAppend(StammMenu,NeuerEintrag)
  else
  begin
    NeuerEintrag^.Next := NeuePosition;
    P := StammMenu;
    while (P^.Next <> NIL) and (P^.Next <> NeuePosition) do P := P^.Next;
    if (P^.Next = NeuePosition) then P^.Next := NeuerEintrag
    else if (P^.Next = NIL) then _RollMenuAppend(StammMenu,NeuerEintrag);
  end;
end;

Procedure RollMenuAppend(var Menu : RollMenuType; NeuerInhalt : RollMenuInhaltType);
var Neuer : PRollMenuZeile;
begin
  if (MemAvail > SizeOf(RollMenuZeile)) then
  begin
    New(Neuer);
    with Neuer^ do
    begin
      Inhalt := NeuerInhalt;
      Next := NIL;
    end;
    _RollMenuAppend(Menu.Zeilen,Neuer);
  end;
end;

Procedure RollMenuInsert(var Menu : RollMenuType; Index : Word; NeuerInhalt : RollMenuInhaltType);
{eine Menuzeile VOR die mit Index bezeichnete Zeile einfgen}
var Neuer : PRollMenuZeile;
begin
  if (MemAvail > SizeOf(RollMenuZeile)) then
  begin
    New(Neuer);
    with Neuer^ do
    begin
      Inhalt := NeuerInhalt;
      Next := NIL;
    end;
    if (Index <= 0) then Index := 1;
    _RollMenuInsert(Menu.Zeilen,RollMenuIndex(Menu.Zeilen,Index),Neuer);
  end;
end;

Procedure RollMenuDelete(var Menu : RollMenuType; Index : Word);
{die mit Index (gezhlt von 1 bis ..) bezeichnete Menuzeile entfernen}
Var P, Alter : PRollMenuZeile;
begin
  Alter := RollMenuIndex(Menu.Zeilen,Index);
  if (Alter <> NIL) then
  begin
    if (Index = 1) then
    begin
      if (Menu.Zeilen^.Next = NIL) then Menu.Zeilen := NIL
      else Menu.Zeilen := Menu.Zeilen^.Next;
    end
    else
    begin
      P := RollMenuIndex(Menu.Zeilen,Pred(Index));
      if (P <> NIL) then P^.Next := Alter^.Next;
    end;
    Dispose(Alter);
  end;
end;

Procedure RollMenuZeileDisplay(Zeile : PRollMenuZeile; Breite : Word);
Var L : String[60];
begin
  if (Zeile <> NIL) then
  begin
    if Breite > 60 then Breite := 60;
    if (Length(Zeile^.Inhalt) > (Breite - 2))
    then L := ' ' + Copy(Zeile^.Inhalt,1,Breite - 2) + ' '
    else
    begin
      L := ' ' + Zeile^.Inhalt;
      FillChar(L[Length(L) + 1],Breite - Length(L),' ');
      L[0] := Chr(Breite);
    end;
    write(L);
  end;
end;

Procedure RollMenuDisplay(MenuWurzel : PRollMenuZeile;
                          Von, Bis : Word; x0,y0,Breite : Word);
Var Loop : Word;
    P : PRollMenuZeile;
begin
  TextColor(0);
  TextBackground(3);
  P := RollMenuIndex(MenuWurzel,Von);
  for Loop := Von to Bis do
  begin
    GotoXY(x0 + 1,y0 + Loop - Von + 1);
    RollMenuZeileDisplay(P,Breite - 2);
    if (P <> NIL) then P := P^.Next;
  end;
end;

Procedure RollMenuHighlight(MenuWurzel : PRollMenuZeile; Nr : Word;
                            Von : Word; x0,y0,Breite : Word; High : Boolean);
Var P : PRollMenuZeile;
begin
  P := RollMenuIndex(MenuWurzel,Nr);
  if High then
  begin
    TextColor(15);
    TextBackground(0);
  end
  else
  begin
    TextColor(0);
    TextBackground(3);
  end;
  GotoXY(x0 + 1,y0 + Nr - Von + 1);
  RollMenuZeileDisplay(P,Breite - 2);
end;


Function RollMenuAktion(var Menu : RollMenuType; Taste : Word) : Word;
Var Erg : Word; {Index-Nr, ausgewhlter Menupunkt}
    P : PRollMenuZeile;

  Procedure Scroll(Down : Boolean);
  var OldWinMax, OldWinMin : Word;
  begin
    OldWinMax := WindMax;
    OldWinMin := WindMin;
    with Menu do
    begin
      Window(x0 +1, y0 + 1, x0 + Breite - 2, y0 + DownIndex - TopIndex + 1);
      if Down then
      begin
        GotoXY(1,1);
        InsLine;
      end
      else
      begin
        GotoXY(1,DownIndex - TopIndex + 1);
        writeln;
      end;
    end;
    WindMax := OldWinMax;
    WindMin := OldWinMin;
  end;

begin
  Erg := 0;
  case Taste of
    CursorUp : with Menu do begin
      if (AktuIndex = 1) then {no action}
      else if (AktuIndex = TopIndex) then
      begin
        RollMenuHighLight(Zeilen,AktuIndex,TopIndex,x0,y0,Breite,FALSE);
        Dec(TopIndex);
        Dec(DownIndex);
        Dec(AktuIndex);
        Scroll(TRUE);
        RollMenuHighLight(Zeilen,AktuIndex,TopIndex,x0,y0,Breite,TRUE);
      end
      else
      begin
        RollMenuHighLight(Zeilen,AktuIndex,TopIndex,x0,y0,Breite,FALSE);
        Dec(AktuIndex);
        RollMenuHighLight(Zeilen,AktuIndex,TopIndex,x0,y0,Breite,TRUE);
      end;
    end;
    CursorDown : with Menu do begin
      P := RollMenuIndex(Zeilen,AktuIndex);
      if (P = NIL) or (P^.Next = NIL) then {no action, Menuende}
      else if (AktuIndex = DownIndex) then
      begin
        RollMenuHighLight(Zeilen,AktuIndex,TopIndex,x0,y0,Breite,FALSE);
        Inc(TopIndex);
        Inc(DownIndex);
        Inc(AktuIndex);
        Scroll(FALSE);
        RollMenuHighLight(Zeilen,AktuIndex,TopIndex,x0,y0,Breite,TRUE);
      end
      else
      begin
        RollMenuHighLight(Zeilen,AktuIndex,TopIndex,x0,y0,Breite,FALSE);
        Inc(AktuIndex);
        RollMenuHighLight(Zeilen,AktuIndex,TopIndex,x0,y0,Breite,TRUE);
      end;
    end;
    SelectTaste : Erg := Menu.AktuIndex;
    EscapeTaste : Erg := 0; {nichts ausgewhlt}
  end;
  RollMenuAktion := Erg;
end;


Procedure RollMenuInit(var Menu : RollMenuType; x,y,hoehe,breite : Word);
begin
  Menu.x0 := x;
  Menu.y0 := y;
  Menu.Breite := breite - 2;
  Menu.TopIndex := 1;
  Menu.DownIndex := hoehe - 2;
  Menu.AktuIndex := 1;
  Menu.Zeilen := NIL;
end;


Procedure RollMenuShow(var Menu : RollMenuType);
begin
  with Menu do
  begin
    RollMenuDisplay(Zeilen,TopIndex,DownIndex,x0,y0,Breite);
    RollMenuHighlight(Zeilen,AktuIndex,TopIndex,x0,y0,Breite,TRUE);
  end;
end;


end. {no inits}



