
{Datei: c:\Pascal\Progs6\ScreenIO.Pas }
{TurboPascal Unit 4.0 - 7.0 ***************************** 26.02.1995}
{Interface zur TP-Unit Crt fr Mrklin-Digital-Loksteuerungsprogramm}
{(c) alle Rechte bei Manfred Fischer, Heroldstr. 44, D-48163 Mnster}

Unit ScreenIO; {Uses Crt, Dos;}

Interface

{Grafische Sonderzeichen, einfache Linienfhrung}
Const LOC = #218; {linke obere Ecke}
      ROC = #191; {rechte obere Ecke}
      RUC = #217; {rechte untere Ecke}
      LUC = #192; {linke untere Ecke}
      TDC = #194; {T}
      TUC = #193; {T kopf stehend}
      TLC = #195; {T links liegend}
      TRC = #180; {T rechts liegend}
      WAC = #196; {waagrecht}
      SEC = #179; {senkrecht}
      CRC = #197; {Cross}

Const LOC2 = #201; {linke obere Ecke}
      ROC2 = #187; {rechte obere Ecke}
      RUC2 = #188; {rechte untere Ecke}
      LUC2 = #200; {linke untere Ecke}
      TDC2 = #203; {T}
      TUC2 = #202; {T kopf stehend}
      TLC2 = #204; {T links liegend}
      TRC2 = #185; {T rechts liegend}
      WAC2 = #205; {waagrecht}
      SEC2 = #186; {senkrecht}
      CRC2 = #206; {Cross}

Const PfeilNachOben  = #30; {Grafikzeichen}
      PfeilNachUnten = #31;
      PfeilNachLinks = #17;
      PfeilNachRechts= #16;

Const  {PC-Tastatur Sondertasten}
   InsertKey = 'R';
   DeleteKey = 'S';
   UpKey     = 'H';
   DownKey   = 'P';
   LeftKey   = 'K';
   RightKey  = 'M';
   NullKey   = #0;
   TabKey    = #9;
   ShiftTabKey = #15;
   EscapeKey = #27;

Function  SekundenZeiger : Word;     {Systemuhr abfragen}
Function  TastaturAktiviert : Boolean;
Function  FuncKey(Ch : Char) : Byte; {0, wenn keine gltige Funktionstaste}
Function  EineAuswahlTaste : Char;   {wartet auf einen Tastendruck ohne Echo}
Function  ReadKeyEcho : Char;        {analog zu Crt.ReadKey, aber mit Echo}
Function  ReadUpCaseKey(Var Ch : Char) : Boolean; {TRUE, wenn Funktionstaste}
Procedure Window(x0,y0,x1,y1 : Byte); {setzt relative Fenstergrenzen neu}
Procedure GotoXY(X, Y : Byte);       {positioniert Cursor im Window}
Procedure WriteXY(X, Y : Byte; S : String);
Function  WhereX : Byte;             {liefert horizontale Cursorposition}
Function  WhereY : Byte;             {liefert vertikale Cursorposition}
Procedure Farben(Stift, Papier : Integer); {Wert == -1, dann nicht ndern}
Procedure LoescheZeile(ZeilenNr : Word);
Procedure LoescheBildschirm;
Procedure RetteFensterGrenzen(var OldMin, OldMax : Word);
Procedure SetzeFensterGrenzen(OldMin, OldMax : Word);
Function  WindMaxX : Word; {horizontale Position des rechten Fensterrandes}
Function  WindMaxY : Word; {vertikale Position des unteren Fensterrandes}
Procedure RetteAltenVideoMode;
Procedure UmschaltenFont8x8;
Procedure SetzeAltenVideoMode;
Procedure MakeFenster(x0,y0,x1,y1 : Word;Art : Byte);
Procedure WriteWithButtons(S : String);
Procedure Beep;
Procedure Delay(Millisekunden : Word); {Zeitverzgerung}


Implementation

Uses Crt, Dos;

{aus System werden verwendet: UpCase();
 aus Dos werden verwendet: GetTime();
 aus Crt werden verwendet: ClrEol, ClrScr, GotoXY(),
                           TextColor(), TextBackground(),
                           WhereX, WhereY, Window(), TextMode(),
                           WindMin, WindMax, TextAttr, LastMode,
                           Font8x8; ReadKey, KeyPressed.}

Var StartVideoMode : Integer; {lokal, um alten Zustand wiederherzustellen}


Function SekundenZeiger : Word;
Var Hour, Minute, Seconds, Milliseconds : Word;
begin
  Dos.GetTime(Hour,Minute,Seconds,Milliseconds);
  SekundenZeiger := Seconds;
end;


Function TastaturAktiviert : Boolean;
begin
  TastaturAktiviert := Crt.KeyPressed;
end;

Function FuncKey(Ch : Char) : Byte;
begin {liefert 0, wenn keine gltige Funktionstaste}
  case Ch of
    ';'..'D' : FuncKey := Succ(Ord(Ch) - Ord(';'));
    'T'..#93 : FuncKey := Succ(Ord(Ch) - Ord('T')) + 10; {Shift}
    '^'..'g' : FuncKey := Succ(Ord(Ch) - Ord('^')) + 20; {Ctrl}
    'h'..'q' : FuncKey := Succ(Ord(Ch) - Ord('h')) + 30; {Alt}
    #133..#140 : {AT-Keyboard Tasten F11 + F12 und Kombinationen}
               FuncKey := (((Ord(Ch) - 133) DIV 2) * 10)
                          + Succ((Ord(Ch) - 133) MOD 2)
    else FuncKey := 0; {d.h. keine gltige Funktionstaste}
  end;
end;

Function EineAuswahlTaste : Char;
begin
  repeat until Crt.Keypressed; EineAuswahlTaste := UpCase(ReadKey);
  repeat until not Crt.KeyPressed; {keine weiteren Eingaben zulassen}
end;

Function ReadKeyEcho : Char; {analog zu Crt.ReadKey, aber mit Echo}
Var Ch : Char;
begin
  Ch := Crt.ReadKey;
  write(Ch);
  ReadKeyEcho := Ch;
end;

Function ReadUpCaseKey(Var Ch : Char) : Boolean; {TRUE, wenn Funktionstaste}
begin
  Ch := UpCase(Crt.ReadKey);
  if Crt.KeyPressed and (Ch = NullKey) then  {Funktionstaste}
  begin
    Ch := Crt.ReadKey;
    ReadUpCaseKey := TRUE;
  end
  else ReadUpCaseKey := FALSE;
end;

Procedure Window(x0,y0,x1,y1 : Byte); {setzt relative Fenstergrenzen neu}
begin
  Crt.Window(x0,y0,x1,y1);
end;

Procedure GotoXY(X, Y : Byte); {positioniert Cursor im Window}
begin
  Crt.GotoXY(X,Y);
end;

Procedure WriteXY(X, Y : Byte; S : String);
begin
  Crt.GotoXY(X,Y);
  write(S);
end;

Function WhereX : Byte; {liefert horizontale Cursorposition}
begin
  WhereX := Crt.WhereX;
end;

Function WhereY : Byte; {liefert vertikale Cursorposition}
begin
  WhereY := Crt.WhereY;
end;

Procedure Farben(Stift, Papier : Integer);
begin {wenn Wert = -1, dann nicht ndern}
  if (Stift >= 0) then Crt.TextColor(Stift); {Vordergrund, Buchstabenfarbe}
  if (Papier >= 0) then Crt.TextBackground(Papier); {Hintergrund}
end;

Procedure LoescheZeile(ZeilenNr : Word);
begin
  Crt.GotoXY(1,ZeilenNr);
  Crt.ClrEol;
end;

Procedure LoescheBildschirm;
begin
  Crt.ClrScr; {ganzen Bildschirm lschen}
end;

Procedure RetteFensterGrenzen(var OldMin, OldMax : Word);
begin
  OldMin := Crt.WindMin;
  OldMax := Crt.WindMax;
end;

Procedure SetzeFensterGrenzen(OldMin, OldMax : Word);
begin
  Crt.WindMin := OldMin;
  Crt.WindMax := OldMax;
end;

Function WindMaxX : Word; {horiz. Position des rechten Fensterrandes}
begin
  WindMaxX := Succ(Lo(Crt.WindMax))
end;

Function WindMaxY : Word; {vertikale Position des unteren Fensterrandes}
begin
  WindMaxY := Succ(Hi(Crt.WindMax))
end;

Procedure RetteAltenVideoMode;
begin
  StartVideoMode := Crt.LastMode;
end;

Procedure UmschaltenFont8x8;
begin
  Crt.TextMode(Lo(StartVideoMode) + Crt.Font8x8);
end;

Procedure SetzeAltenVideoMode;
begin
  Crt.TextMode(StartVideoMode);
end;

Procedure MakeFenster(x0,y0,x1,y1 : Word;Art : Byte);
{verwendet NICHT die Prozedur Crt.Window()}
Const Rahmen : array[0..2,1..6] of Char = ((' ',' ',' ',' ',' ',' '),
       (LOC,ROC,LUC,RUC,WAC,SEC),(LOC2,ROC2,LUC2,RUC2,WAC2,SEC2));
Var Loop, x, y, xende : Word;
    Line : String[255];
begin
  {Rahmen mit Grundflche}
  if (x0 < 1) then x := 1 else x := x0;
  if (y0 < 1) then y := 1 else y := y0;
  if (x1 > WindMaxX) then xende := WindMaxX
  else xende := x1;

  {oberste Zeile}
  FillChar(Line[1],255,Rahmen[Art,5]);
  Line[0] := Chr(255);
  Line[1] := Rahmen[Art,1];
  if ((x1 - x0) < 255) then Line[Succ(x1 - x0)] := Rahmen[Art,2];
  if (x0 > 0) then Loop := Succ(xende - x0)
  else Loop := Succ(xende - x);
  Crt.GotoXY(x,y);
  write(Copy(Line,1,Loop));

  {unterste Zeile}
  Line[1] := Rahmen[Art,3];
  if ((x1 - x0) < 255) then Line[Succ(x1 - x0)] := Rahmen[Art,4];
  if (y1 <= WindMaxY) then
  begin
    if (y1 < WindMaxY) then Loop := 1 else Loop := 0;
    if (x0 > 0) then Loop := Loop + xende - x0
    else Loop := Loop + xende - x;
    Crt.GotoXY(x,y1);
    write(Copy(Line,1,Loop));
  end;

  {alle anderen Zeilen dazwischen}
  FillChar(Line[1],255,' ');
  Line[1] := Rahmen[Art,6];
  if ((x1 - x0) < 255) then Line[Succ(x1 - x0)] := Rahmen[Art,6];
  if (y1 > WindMaxY) then y1 := WindMaxY + 1;
  for Loop := Succ(y) to Pred(y1) do
  begin
    Crt.GotoXY(x,Loop);
    if (x0 > 0) then write(Copy(Line,1,(xende-x0)))
    else write(Copy(Line,2,(xende-x)));
    if (Loop < WindMaxY)
    or ((Crt.WhereX <> WindMaxX) and (Loop = WindMaxY)) then
    begin
      write(Copy(Line,Succ(xende-x0),1))
    end;
  end;
end;

Procedure WriteWithButtons(S : String);
Var Loop : Word;
    OTextAttr : Byte;
begin
  for Loop := 1 to Length(S) do
  begin
    if S[Loop] in ['A'..'Z','','','',#144,#165] then
    begin
      OTextAttr := Crt.TextAttr;
      Farben(White,-1); write('[');
      Farben(Yellow,-1); write(S[Loop]);
      Farben(White,-1); write(']');
      Crt.TextAttr := OTextAttr;
    end
    else write(S[Loop]);
  end;
end;

Procedure Beep;
Const BEL = #7;
begin
  write(BEL); {PC Speaker}
end;

Procedure Delay(Millisekunden : Word); {Zeitverzgerung}
begin
  Crt.Delay(Millisekunden);
end;


begin {Inits dieser Unit}
  RetteAltenVideoMode; {setzt Variable StartVideoMode}
end.

